﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace asprise_imaging_api
{
    /// <summary>
    /// TWAIN contants.
    /// </summary>
    public class TwainConstants
    {

        public const int CAP_CUSTOMBASE = 0x8000; /* Base of custom capabilities */

        /* all data sources are REQUIRED to support these caps */
        public const int CAP_XFERCOUNT = 0x0001;

        /* image data sources are REQUIRED to support these caps */
        public const int ICAP_COMPRESSION = 0x0100;
        public const int ICAP_PIXELTYPE = 0x0101;
        public const int ICAP_UNITS = 0x0102;
        public const int ICAP_XFERMECH = 0x0103;

        /* all data sources MAY support these caps */
        public const int CAP_AUTHOR = 0x1000;
        public const int CAP_CAPTION = 0x1001;
        public const int CAP_FEEDERENABLED = 0x1002;
        public const int CAP_FEEDERLOADED = 0x1003;
        public const int CAP_TIMEDATE = 0x1004;
        public const int CAP_SUPPORTEDCAPS = 0x1005;
        public const int CAP_EXTENDEDCAPS = 0x1006;
        public const int CAP_AUTOFEED = 0x1007;
        public const int CAP_CLEARPAGE = 0x1008;
        public const int CAP_FEEDPAGE = 0x1009;
        public const int CAP_REWINDPAGE = 0x100a;
        public const int CAP_INDICATORS = 0x100b;
        public const int CAP_PAPERDETECTABLE = 0x100d;
        public const int CAP_UICONTROLLABLE = 0x100e;
        public const int CAP_DEVICEONLINE = 0x100f;
        public const int CAP_AUTOSCAN = 0x1010;
        public const int CAP_THUMBNAILSENABLED = 0x1011;
        public const int CAP_DUPLEX = 0x1012;
        public const int CAP_DUPLEXENABLED = 0x1013;
        public const int CAP_ENABLEDSUIONLY = 0x1014;
        public const int CAP_CUSTOMDSDATA = 0x1015;
        public const int CAP_ENDORSER = 0x1016;
        public const int CAP_JOBCONTROL = 0x1017;
        public const int CAP_ALARMS = 0x1018;
        public const int CAP_ALARMVOLUME = 0x1019;
        public const int CAP_AUTOMATICCAPTURE = 0x101a;
        public const int CAP_TIMEBEFOREFIRSTCAPTURE = 0x101b;
        public const int CAP_TIMEBETWEENCAPTURES = 0x101c;
        public const int CAP_CLEARBUFFERS = 0x101d;
        public const int CAP_MAXBATCHBUFFERS = 0x101e;
        public const int CAP_DEVICETIMEDATE = 0x101f;
        public const int CAP_POWERSUPPLY = 0x1020;
        public const int CAP_CAMERAPREVIEWUI = 0x1021;
        public const int CAP_DEVICEEVENT = 0x1022;
        public const int CAP_SERIALNUMBER = 0x1024;
        public const int CAP_PRINTER = 0x1026;
        public const int CAP_PRINTERENABLED = 0x1027;
        public const int CAP_PRINTERINDEX = 0x1028;
        public const int CAP_PRINTERMODE = 0x1029;
        public const int CAP_PRINTERSTRING = 0x102a;
        public const int CAP_PRINTERSUFFIX = 0x102b;
        public const int CAP_LANGUAGE = 0x102c;
        public const int CAP_FEEDERALIGNMENT = 0x102d;
        public const int CAP_FEEDERORDER = 0x102e;
        public const int CAP_REACQUIREALLOWED = 0x1030;
        public const int CAP_BATTERYMINUTES = 0x1032;
        public const int CAP_BATTERYPERCENTAGE = 0x1033;
        public const int CAP_CAMERASIDE = 0x1034;
        public const int CAP_SEGMENTED = 0x1035;
        public const int CAP_CAMERAENABLED = 0x1036;
        public const int CAP_CAMERAORDER = 0x1037;
        public const int CAP_MICRENABLED = 0x1038;
        public const int CAP_FEEDERPREP = 0x1039;
        public const int CAP_FEEDERPOCKET = 0x103a;
        public const int CAP_AUTOMATICSENSEMEDIUM = 0x103b;
        public const int CAP_CUSTOMINTERFACEGUID = 0x103c;
        public const int CAP_SUPPORTEDCAPSSEGMENTUNIQUE = 0x103d;
        public const int CAP_SUPPORTEDDATS = 0x103e;
        public const int CAP_DOUBLEFEEDDETECTION = 0x103f;
        public const int CAP_DOUBLEFEEDDETECTIONLENGTH = 0x1040;
        public const int CAP_DOUBLEFEEDDETECTIONSENSITIVITY = 0x1041;
        public const int CAP_DOUBLEFEEDDETECTIONRESPONSE = 0x1042;
        public const int CAP_PAPERHANDLING = 0x1043;
        public const int CAP_INDICATORSMODE = 0x1044;
        public const int CAP_PRINTERVERTICALOFFSET = 0x1045;
        public const int CAP_POWERSAVETIME = 0x1046;
        public const int CAP_PRINTERCHARROTATION = 0x1047;
        public const int CAP_PRINTERFONTSTYLE = 0x1048;
        public const int CAP_PRINTERINDEXLEADCHAR = 0x1049;
        public const int CAP_PRINTERINDEXMAXVALUE = 0x104A;
        public const int CAP_PRINTERINDEXNUMDIGITS = 0x104B;
        public const int CAP_PRINTERINDEXSTEP = 0x104C;
        public const int CAP_PRINTERINDEXTRIGGER = 0x104D;
        public const int CAP_PRINTERSTRINGPREVIEW = 0x104E;

        /* image data sources MAY support these caps */
        public const int ICAP_AUTOBRIGHT = 0x1100;
        public const int ICAP_BRIGHTNESS = 0x1101;
        public const int ICAP_CONTRAST = 0x1103;
        public const int ICAP_CUSTHALFTONE = 0x1104;
        public const int ICAP_EXPOSURETIME = 0x1105;
        public const int ICAP_FILTER = 0x1106;
        public const int ICAP_FLASHUSED = 0x1107;
        public const int ICAP_GAMMA = 0x1108;
        public const int ICAP_HALFTONES = 0x1109;
        public const int ICAP_HIGHLIGHT = 0x110a;
        public const int ICAP_IMAGEFILEFORMAT = 0x110c;
        public const int ICAP_LAMPSTATE = 0x110d;
        public const int ICAP_LIGHTSOURCE = 0x110e;
        public const int ICAP_ORIENTATION = 0x1110;
        public const int ICAP_PHYSICALWIDTH = 0x1111;
        public const int ICAP_PHYSICALHEIGHT = 0x1112;
        public const int ICAP_SHADOW = 0x1113;
        public const int ICAP_FRAMES = 0x1114;
        public const int ICAP_XNATIVERESOLUTION = 0x1116;
        public const int ICAP_YNATIVERESOLUTION = 0x1117;
        public const int ICAP_XRESOLUTION = 0x1118;
        public const int ICAP_YRESOLUTION = 0x1119;
        public const int ICAP_MAXFRAMES = 0x111a;
        public const int ICAP_TILES = 0x111b;
        public const int ICAP_BITORDER = 0x111c;
        public const int ICAP_CCITTKFACTOR = 0x111d;
        public const int ICAP_LIGHTPATH = 0x111e;
        public const int ICAP_PIXELFLAVOR = 0x111f;
        public const int ICAP_PLANARCHUNKY = 0x1120;
        public const int ICAP_ROTATION = 0x1121;
        public const int ICAP_SUPPORTEDSIZES = 0x1122;
        public const int ICAP_THRESHOLD = 0x1123;
        public const int ICAP_XSCALING = 0x1124;
        public const int ICAP_YSCALING = 0x1125;
        public const int ICAP_BITORDERCODES = 0x1126;
        public const int ICAP_PIXELFLAVORCODES = 0x1127;
        public const int ICAP_JPEGPIXELTYPE = 0x1128;
        public const int ICAP_TIMEFILL = 0x112a;
        public const int ICAP_BITDEPTH = 0x112b;
        public const int ICAP_BITDEPTHREDUCTION = 0x112c;
        public const int ICAP_UNDEFINEDIMAGESIZE = 0x112d;
        public const int ICAP_IMAGEDATASET = 0x112e;
        public const int ICAP_EXTIMAGEINFO = 0x112f;
        public const int ICAP_MINIMUMHEIGHT = 0x1130;
        public const int ICAP_MINIMUMWIDTH = 0x1131;
        public const int ICAP_AUTODISCARDBLANKPAGES = 0x1134;
        public const int ICAP_FLIPROTATION = 0x1136;
        public const int ICAP_BARCODEDETECTIONENABLED = 0x1137;
        public const int ICAP_SUPPORTEDBARCODETYPES = 0x1138;
        public const int ICAP_BARCODEMAXSEARCHPRIORITIES = 0x1139;
        public const int ICAP_BARCODESEARCHPRIORITIES = 0x113a;
        public const int ICAP_BARCODESEARCHMODE = 0x113b;
        public const int ICAP_BARCODEMAXRETRIES = 0x113c;
        public const int ICAP_BARCODETIMEOUT = 0x113d;
        public const int ICAP_ZOOMFACTOR = 0x113e;
        public const int ICAP_PATCHCODEDETECTIONENABLED = 0x113f;
        public const int ICAP_SUPPORTEDPATCHCODETYPES = 0x1140;
        public const int ICAP_PATCHCODEMAXSEARCHPRIORITIES = 0x1141;
        public const int ICAP_PATCHCODESEARCHPRIORITIES = 0x1142;
        public const int ICAP_PATCHCODESEARCHMODE = 0x1143;
        public const int ICAP_PATCHCODEMAXRETRIES = 0x1144;
        public const int ICAP_PATCHCODETIMEOUT = 0x1145;
        public const int ICAP_FLASHUSED2 = 0x1146;
        public const int ICAP_IMAGEFILTER = 0x1147;
        public const int ICAP_NOISEFILTER = 0x1148;
        public const int ICAP_OVERSCAN = 0x1149;
        public const int ICAP_AUTOMATICBORDERDETECTION = 0x1150;
        public const int ICAP_AUTOMATICDESKEW = 0x1151;
        public const int ICAP_AUTOMATICROTATE = 0x1152;
        public const int ICAP_JPEGQUALITY = 0x1153;
        public const int ICAP_FEEDERTYPE = 0x1154;
        public const int ICAP_ICCPROFILE = 0x1155;
        public const int ICAP_AUTOSIZE = 0x1156;
        public const int ICAP_AUTOMATICCROPUSESFRAME = 0x1157;
        public const int ICAP_AUTOMATICLENGTHDETECTION = 0x1158;
        public const int ICAP_AUTOMATICCOLORENABLED = 0x1159;
        public const int ICAP_AUTOMATICCOLORNONCOLORPIXELTYPE = 0x115a;
        public const int ICAP_COLORMANAGEMENTENABLED = 0x115b;
        public const int ICAP_IMAGEMERGE = 0x115c;
        public const int ICAP_IMAGEMERGEHEIGHTTHRESHOLD = 0x115d;
        public const int ICAP_SUPPORTEDEXTIMAGEINFO = 0x115e;
        public const int ICAP_FILMTYPE = 0x115f;
        public const int ICAP_MIRROR = 0x1160;
        public const int ICAP_JPEGSUBSAMPLING = 0x1161;

        public const int CAP_SUPPORTEDCAPSEXT = 0x100c;
        public const int CAP_PAGEMULTIPLEACQUIRE = 0x1023;
        public const int CAP_PAPERBINDING = 0x102f;
        public const int CAP_PASSTHRU = 0x1031;
        public const int CAP_POWERDOWNTIME = 0x1034;

        // TWEI
        public const int TWEI_BARCODEX = 0x1200;
        public const int TWEI_BARCODEY = 0x1201;
        public const int TWEI_BARCODETEXT = 0x1202;
        public const int TWEI_BARCODETYPE = 0x1203;
        public const int TWEI_DESHADETOP = 0x1204;
        public const int TWEI_DESHADELEFT = 0x1205;
        public const int TWEI_DESHADEHEIGHT = 0x1206;
        public const int TWEI_DESHADEWIDTH = 0x1207;
        public const int TWEI_DESHADESIZE = 0x1208;
        public const int TWEI_SPECKLESREMOVED = 0x1209;
        public const int TWEI_HORZLINEXCOORD = 0x120A;
        public const int TWEI_HORZLINEYCOORD = 0x120B;
        public const int TWEI_HORZLINELENGTH = 0x120C;
        public const int TWEI_HORZLINETHICKNESS = 0x120D;
        public const int TWEI_VERTLINEXCOORD = 0x120E;
        public const int TWEI_VERTLINEYCOORD = 0x120F;
        public const int TWEI_VERTLINELENGTH = 0x1210;
        public const int TWEI_VERTLINETHICKNESS = 0x1211;
        public const int TWEI_PATCHCODE = 0x1212;
        public const int TWEI_ENDORSEDTEXT = 0x1213;
        public const int TWEI_FORMCONFIDENCE = 0x1214;
        public const int TWEI_FORMTEMPLATEMATCH = 0x1215;
        public const int TWEI_FORMTEMPLATEPAGEMATCH = 0x1216;
        public const int TWEI_FORMHORZDOCOFFSET = 0x1217;
        public const int TWEI_FORMVERTDOCOFFSET = 0x1218;
        public const int TWEI_BARCODECOUNT = 0x1219;
        public const int TWEI_BARCODECONFIDENCE = 0x121A;
        public const int TWEI_BARCODEROTATION = 0x121B;
        public const int TWEI_BARCODETEXTLENGTH = 0x121C;
        public const int TWEI_DESHADECOUNT = 0x121D;
        public const int TWEI_DESHADEBLACKCOUNTOLD = 0x121E;
        public const int TWEI_DESHADEBLACKCOUNTNEW = 0x121F;
        public const int TWEI_DESHADEBLACKRLMIN = 0x1220;
        public const int TWEI_DESHADEBLACKRLMAX = 0x1221;
        public const int TWEI_DESHADEWHITECOUNTOLD = 0x1222;
        public const int TWEI_DESHADEWHITECOUNTNEW = 0x1223;
        public const int TWEI_DESHADEWHITERLMIN = 0x1224;
        public const int TWEI_DESHADEWHITERLAVE = 0x1225;
        public const int TWEI_DESHADEWHITERLMAX = 0x1226;
        public const int TWEI_BLACKSPECKLESREMOVED = 0x1227;
        public const int TWEI_WHITESPECKLESREMOVED = 0x1228;
        public const int TWEI_HORZLINECOUNT = 0x1229;
        public const int TWEI_VERTLINECOUNT = 0x122A;
        public const int TWEI_DESKEWSTATUS = 0x122B;
        public const int TWEI_SKEWORIGINALANGLE = 0x122C;
        public const int TWEI_SKEWFINALANGLE = 0x122D;
        public const int TWEI_SKEWCONFIDENCE = 0x122E;
        public const int TWEI_SKEWWINDOWX1 = 0x122F;
        public const int TWEI_SKEWWINDOWY1 = 0x1230;
        public const int TWEI_SKEWWINDOWX2 = 0x1231;
        public const int TWEI_SKEWWINDOWY2 = 0x1232;
        public const int TWEI_SKEWWINDOWX3 = 0x1233;
        public const int TWEI_SKEWWINDOWY3 = 0x1234;
        public const int TWEI_SKEWWINDOWX4 = 0x1235;
        public const int TWEI_SKEWWINDOWY4 = 0x1236;
        public const int TWEI_BOOKNAME = 0x1238;
        public const int TWEI_CHAPTERNUMBER = 0x1239;
        public const int TWEI_DOCUMENTNUMBER = 0x123A;
        public const int TWEI_PAGENUMBER = 0x123B;
        public const int TWEI_CAMERA = 0x123C;
        public const int TWEI_FRAMENUMBER = 0x123D;
        public const int TWEI_FRAME = 0x123E;
        public const int TWEI_PIXELFLAVOR = 0x123F;
        public const int TWEI_ICCPROFILE = 0x1240;
        public const int TWEI_LASTSEGMENT = 0x1241;
        public const int TWEI_SEGMENTNUMBER = 0x1242;
        public const int TWEI_MAGDATA = 0x1243;
        public const int TWEI_MAGTYPE = 0x1244;
        public const int TWEI_PAGESIDE = 0x1245;
        public const int TWEI_FILESYSTEMSOURCE = 0x1246;
        public const int TWEI_IMAGEMERGED = 0x1247;
        public const int TWEI_MAGDATALENGTH = 0x1248;
        public const int TWEI_PAPERCOUNT = 0x1249;
        public const int TWEI_PRINTERTEXT = 0x124A;

        public const int TWEJ_NONE = 0x0000;
        public const int TWEJ_MIDSEPARATOR = 0x0001;
        public const int TWEJ_PATCH1 = 0x0002;
        public const int TWEJ_PATCH2 = 0x0003;
        public const int TWEJ_PATCH3 = 0x0004;
        public const int TWEJ_PATCH4 = 0x0005;
        public const int TWEJ_PATCH6 = 0x0006;
        public const int TWEJ_PATCHT = 0x0007;


        /***************************************************************************
         *            Return Codes and Condition Codes section                     *
         ***************************************************************************/

        public const int TWRC_CUSTOMBASE = 0x8000;

        public const int TWRC_SUCCESS = 0;
        public const int TWRC_FAILURE = 1;
        public const int TWRC_CHECKSTATUS = 2;
        public const int TWRC_CANCEL = 3;
        public const int TWRC_DSEVENT = 4;
        public const int TWRC_NOTDSEVENT = 5;
        public const int TWRC_XFERDONE = 6;
        public const int TWRC_ENDOFLIST = 7;
        public const int TWRC_INFONOTSUPPORTED = 8;
        public const int TWRC_DATANOTAVAILABLE = 9;
        public const int TWRC_BUSY = 10;
        public const int TWRC_SCANNERLOCKED = 11;

        /* Condition Codes: Application gets these by doing DG_CONTROL DAT_STATUS MSG_GET.  */
        public const int TWCC_CUSTOMBASE = 0x8000;

        public const int TWCC_SUCCESS = 0;
        public const int TWCC_BUMMER = 1;
        public const int TWCC_LOWMEMORY = 2;
        public const int TWCC_NODS = 3;
        public const int TWCC_MAXCONNECTIONS = 4;
        public const int TWCC_OPERATIONERROR = 5;
        public const int TWCC_BADCAP = 6;
        public const int TWCC_BADPROTOCOL = 9;
        public const int TWCC_BADVALUE = 10;
        public const int TWCC_SEQERROR = 11;
        public const int TWCC_BADDEST = 12;
        public const int TWCC_CAPUNSUPPORTED = 13;
        public const int TWCC_CAPBADOPERATION = 14;
        public const int TWCC_CAPSEQERROR = 15;
        public const int TWCC_DENIED = 16;
        public const int TWCC_FILEEXISTS = 17;
        public const int TWCC_FILENOTFOUND = 18;
        public const int TWCC_NOTEMPTY = 19;
        public const int TWCC_PAPERJAM = 20;
        public const int TWCC_PAPERDOUBLEFEED = 21;
        public const int TWCC_FILEWRITEERROR = 22;
        public const int TWCC_CHECKDEVICEONLINE = 23;
        public const int TWCC_INTERLOCK = 24;
        public const int TWCC_DAMAGEDCORNER = 25;
        public const int TWCC_FOCUSERROR = 26;
        public const int TWCC_DOCTOOLIGHT = 27;
        public const int TWCC_DOCTOODARK = 28;
        public const int TWCC_NOMEDIA = 29;

        /* CAP_CLEARBUFFERS values */
        public const int TWCB_AUTO = 0;
        public const int TWCB_CLEAR = 1;
        public const int TWCB_NOCLEAR = 2;

        /* TW_PASSTHRU.Direction values. */
        public const int TWDR_GET = 1;
        public const int TWDR_SET = 2;

        /* TWEI_DESKEWSTATUS values. */
        public const int TWDSK_SUCCESS = 0;
        public const int TWDSK_REPORTONLY = 1;
        public const int TWDSK_FAIL = 2;
        public const int TWDSK_DISABLED = 3;

        /* CAP_DUPLEX values */
        public const int TWDX_NONE = 0;
        public const int TWDX_1PASSDUPLEX = 1;
        public const int TWDX_2PASSDUPLEX = 2;

        /* CAP_FEEDERALIGNMENT values */
        public const int TWFA_NONE = 0;
        public const int TWFA_LEFT = 1;
        public const int TWFA_CENTER = 2;
        public const int TWFA_RIGHT = 3;

        /* ICAP_FEEDERTYPE values*/
        public const int TWFE_GENERAL = 0;
        public const int TWFE_PHOTO = 1;

        /* ICAP_IMAGEFILEFORMAT values */
        public const int TWFF_TIFF = 0;
        public const int TWFF_PICT = 1;
        public const int TWFF_BMP = 2;
        public const int TWFF_XBM = 3;
        public const int TWFF_JFIF = 4;
        public const int TWFF_FPX = 5;
        public const int TWFF_TIFFMULTI = 6;
        public const int TWFF_PNG = 7;
        public const int TWFF_SPIFF = 8;
        public const int TWFF_EXIF = 9;
        public const int TWFF_PDF = 10;
        public const int TWFF_JP2 = 11;
        public const int TWFF_JPX = 13;
        public const int TWFF_DEJAVU = 14;
        public const int TWFF_PDFA = 15;
        public const int TWFF_PDFA2 = 16;

        /* ICAP_FLASHUSED2 values */
        public const int TWFL_NONE = 0;
        public const int TWFL_OFF = 1;
        public const int TWFL_ON = 2;
        public const int TWFL_AUTO = 3;
        public const int TWFL_REDEYE = 4;

        /* CAP_FEEDERORDER values */
        public const int TWFO_FIRSTPAGEFIRST = 0;
        public const int TWFO_LASTPAGEFIRST = 1;

        /* CAP_FEEDERPOCKET values*/
        public const int TWFP_POCKETERROR = 0;
        public const int TWFP_POCKET1 = 1;
        public const int TWFP_POCKET2 = 2;
        public const int TWFP_POCKET3 = 3;
        public const int TWFP_POCKET4 = 4;
        public const int TWFP_POCKET5 = 5;
        public const int TWFP_POCKET6 = 6;
        public const int TWFP_POCKET7 = 7;
        public const int TWFP_POCKET8 = 8;
        public const int TWFP_POCKET9 = 9;
        public const int TWFP_POCKET10 = 10;
        public const int TWFP_POCKET11 = 11;
        public const int TWFP_POCKET12 = 12;
        public const int TWFP_POCKET13 = 13;
        public const int TWFP_POCKET14 = 14;
        public const int TWFP_POCKET15 = 15;
        public const int TWFP_POCKET16 = 16;

        /* ICAP_FLIPROTATION values */
        public const int TWFR_BOOK = 0;
        public const int TWFR_FANFOLD = 1;

        /* ICAP_FILTER values */
        public const int TWFT_RED = 0;
        public const int TWFT_GREEN = 1;
        public const int TWFT_BLUE = 2;
        public const int TWFT_NONE = 3;
        public const int TWFT_WHITE = 4;
        public const int TWFT_CYAN = 5;
        public const int TWFT_MAGENTA = 6;
        public const int TWFT_YELLOW = 7;
        public const int TWFT_BLACK = 8;

        /* ICAP_LIGHTPATH values */
        public const int TWLP_REFLECTIVE = 0;
        public const int TWLP_TRANSMISSIVE = 1;

        /* ICAP_LIGHTSOURCE values */
        public const int TWLS_RED = 0;
        public const int TWLS_GREEN = 1;
        public const int TWLS_BLUE = 2;
        public const int TWLS_NONE = 3;
        public const int TWLS_WHITE = 4;
        public const int TWLS_UV = 5;
        public const int TWLS_IR = 6;

        /* ICAP_NOISEFILTER values */
        public const int TWNF_NONE = 0;
        public const int TWNF_AUTO = 1;
        public const int TWNF_LONEPIXEL = 2;
        public const int TWNF_MAJORITYRULE = 3;

        /* ICAP_ORIENTATION values */
        public const int TWOR_ROT0 = 0;
        public const int TWOR_ROT90 = 1;
        public const int TWOR_ROT180 = 2;
        public const int TWOR_ROT270 = 3;
        public const int TWOR_PORTRAIT = TWOR_ROT0;
        public const int TWOR_LANDSCAPE = TWOR_ROT270;
        public const int TWOR_AUTO = 4;
        public const int TWOR_AUTOTEXT = 5;
        public const int TWOR_AUTOPICTURE = 6;

        /* ICAP_OVERSCAN values */
        public const int TWOV_NONE = 0;
        public const int TWOV_AUTO = 1;
        public const int TWOV_TOPBOTTOM = 2;
        public const int TWOV_LEFTRIGHT = 3;
        public const int TWOV_ALL = 4;

        /* Palette types for TW_PALETTE8 */
        public const int TWPA_RGB = 0;
        public const int TWPA_GRAY = 1;
        public const int TWPA_CMY = 2;

        /* ICAP_PLANARCHUNKY values */
        public const int TWPC_CHUNKY = 0;
        public const int TWPC_PLANAR = 1;

        /* TWEI_PATCHCODE values*/
        public const int TWPCH_PATCH1 = 0;
        public const int TWPCH_PATCH2 = 1;
        public const int TWPCH_PATCH3 = 2;
        public const int TWPCH_PATCH4 = 3;
        public const int TWPCH_PATCH6 = 4;
        public const int TWPCH_PATCHT = 5;

        /* ICAP_PIXELFLAVOR values */
        public const int TWPF_CHOCOLATE = 0;
        public const int TWPF_VANILLA = 1;

        /* CAP_PRINTERMODE values */
        public const int TWPM_SINGLESTRING = 0;
        public const int TWPM_MULTISTRING = 1;
        public const int TWPM_COMPOUNDSTRING = 2;

        /* CAP_PRINTER values */
        public const int TWPR_IMPRINTERTOPBEFORE = 0;
        public const int TWPR_IMPRINTERTOPAFTER = 1;
        public const int TWPR_IMPRINTERBOTTOMBEFORE = 2;
        public const int TWPR_IMPRINTERBOTTOMAFTER = 3;
        public const int TWPR_ENDORSERTOPBEFORE = 4;
        public const int TWPR_ENDORSERTOPAFTER = 5;
        public const int TWPR_ENDORSERBOTTOMBEFORE = 6;
        public const int TWPR_ENDORSERBOTTOMAFTER = 7;

        /* CAP_PRINTERFONTSTYLE Added 2.3 */
        public const int TWPF_NORMAL = 0;
        public const int TWPF_BOLD = 1;
        public const int TWPF_ITALIC = 2;
        public const int TWPF_LARGESIZE = 3;
        public const int TWPF_SMALLSIZE = 4;

        /* CAP_PRINTERINDEXTRIGGER Added 2.3 */
        public const int TWCT_PAGE = 0;
        public const int TWCT_PATCH1 = 1;
        public const int TWCT_PATCH2 = 2;
        public const int TWCT_PATCH3 = 3;
        public const int TWCT_PATCH4 = 4;
        public const int TWCT_PATCHT = 5;
        public const int TWCT_PATCH6 = 6;

        /* CAP_POWERSUPPLY values */
        public const int TWPS_EXTERNAL = 0;
        public const int TWPS_BATTERY = 1;

        /* ICAP_PIXELTYPE values (PT_ means Pixel Type) */
        public const int TWPT_BW = 0;
        public const int TWPT_GRAY = 1;
        public const int TWPT_RGB = 2;
        public const int TWPT_PALETTE = 3;
        public const int TWPT_CMY = 4;
        public const int TWPT_CMYK = 5;
        public const int TWPT_YUV = 6;
        public const int TWPT_YUVK = 7;
        public const int TWPT_CIEXYZ = 8;
        public const int TWPT_LAB = 9;
        public const int TWPT_SRGB = 10;
        public const int TWPT_SCRGB = 11;
        public const int TWPT_INFRARED = 16;

        /* CAP_SEGMENTED values */
        public const int TWSG_NONE = 0;
        public const int TWSG_AUTO = 1;
        public const int TWSG_MANUAL = 2;

        /* ICAP_FILMTYPE values */
        public const int TWFM_POSITIVE = 0;
        public const int TWFM_NEGATIVE = 1;

        /* CAP_DOUBLEFEEDDETECTION */
        public const int TWDF_ULTRASONIC = 0;
        public const int TWDF_BYLENGTH = 1;
        public const int TWDF_INFRARED = 2;

        /* CAP_DOUBLEFEEDDETECTIONSENSITIVITY */
        public const int TWUS_LOW = 0;
        public const int TWUS_MEDIUM = 1;
        public const int TWUS_HIGH = 2;

        /* CAP_DOUBLEFEEDDETECTIONRESPONSE */
        public const int TWDP_STOP = 0;
        public const int TWDP_STOPANDWAIT = 1;
        public const int TWDP_SOUND = 2;
        public const int TWDP_DONOTIMPRINT = 3;

        /* ICAP_MIRROR values */
        public const int TWMR_NONE = 0;
        public const int TWMR_VERTICAL = 1;
        public const int TWMR_HORIZONTAL = 2;

        /* CAP_PAPERHANDLING values */
        public const int TWPH_NORMAL = 0;
        public const int TWPH_FRAGILE = 1;
        public const int TWPH_THICK = 2;
        public const int TWPH_TRIFOLD = 3;
        public const int TWPH_PHOTOGRAPH = 4;

        /* CAP_INDICATORSMODE values */
        public const int TWCI_INFO = 0;
        public const int TWCI_WARNING = 1;
        public const int TWCI_ERROR = 2;
        public const int TWCI_WARMUP = 3;

        /* ICAP_SUPPORTEDSIZES values (SS_ means Supported Sizes) */
        public const int TWSS_NONE = 0;
        public const int TWSS_A4 = 1;
        public const int TWSS_JISB5 = 2;
        public const int TWSS_USLETTER = 3;
        public const int TWSS_USLEGAL = 4;
        public const int TWSS_A5 = 5;
        public const int TWSS_ISOB4 = 6;
        public const int TWSS_ISOB6 = 7;
        public const int TWSS_USLEDGER = 9;
        public const int TWSS_USEXECUTIVE = 10;
        public const int TWSS_A3 = 11;
        public const int TWSS_ISOB3 = 12;
        public const int TWSS_A6 = 13;
        public const int TWSS_C4 = 14;
        public const int TWSS_C5 = 15;
        public const int TWSS_C6 = 16;
        public const int TWSS_4A0 = 17;
        public const int TWSS_2A0 = 18;
        public const int TWSS_A0 = 19;
        public const int TWSS_A1 = 20;
        public const int TWSS_A2 = 21;
        public const int TWSS_A7 = 22;
        public const int TWSS_A8 = 23;
        public const int TWSS_A9 = 24;
        public const int TWSS_A10 = 25;
        public const int TWSS_ISOB0 = 26;
        public const int TWSS_ISOB1 = 27;
        public const int TWSS_ISOB2 = 28;
        public const int TWSS_ISOB5 = 29;
        public const int TWSS_ISOB7 = 30;
        public const int TWSS_ISOB8 = 31;
        public const int TWSS_ISOB9 = 32;
        public const int TWSS_ISOB10 = 33;
        public const int TWSS_JISB0 = 34;
        public const int TWSS_JISB1 = 35;
        public const int TWSS_JISB2 = 36;
        public const int TWSS_JISB3 = 37;
        public const int TWSS_JISB4 = 38;
        public const int TWSS_JISB6 = 39;
        public const int TWSS_JISB7 = 40;
        public const int TWSS_JISB8 = 41;
        public const int TWSS_JISB9 = 42;
        public const int TWSS_JISB10 = 43;
        public const int TWSS_C0 = 44;
        public const int TWSS_C1 = 45;
        public const int TWSS_C2 = 46;
        public const int TWSS_C3 = 47;
        public const int TWSS_C7 = 48;
        public const int TWSS_C8 = 49;
        public const int TWSS_C9 = 50;
        public const int TWSS_C10 = 51;
        public const int TWSS_USSTATEMENT = 52;
        public const int TWSS_BUSINESSCARD = 53;
        public const int TWSS_MAXSIZE = 54;

        /* ICAP_XFERMECH values (SX_ means Setup XFer) */
        public const int TWSX_NATIVE = 0;
        public const int TWSX_FILE = 1;
        public const int TWSX_MEMORY = 2;
        public const int TWSX_MEMFILE = 4;

        /* ICAP_UNITS values (UN_ means UNits) */
        public const int TWUN_INCHES = 0;
        public const int TWUN_CENTIMETERS = 1;
        public const int TWUN_PICAS = 2;
        public const int TWUN_POINTS = 3;
        public const int TWUN_TWIPS = 4;
        public const int TWUN_PIXELS = 5;
        public const int TWUN_MILLIMETERS = 6;

        /****************************************************************************
         * Country Constants                                                        *
         ****************************************************************************/

        public const int TWCY_AFGHANISTAN = 1001;
        public const int TWCY_ALGERIA = 213;
        public const int TWCY_AMERICANSAMOA = 684;
        public const int TWCY_ANDORRA = 033;
        public const int TWCY_ANGOLA = 1002;
        public const int TWCY_ANGUILLA = 8090;
        public const int TWCY_ANTIGUA = 8091;
        public const int TWCY_ARGENTINA = 54;
        public const int TWCY_ARUBA = 297;
        public const int TWCY_ASCENSIONI = 247;
        public const int TWCY_AUSTRALIA = 61;
        public const int TWCY_AUSTRIA = 43;
        public const int TWCY_BAHAMAS = 8092;
        public const int TWCY_BAHRAIN = 973;
        public const int TWCY_BANGLADESH = 880;
        public const int TWCY_BARBADOS = 8093;
        public const int TWCY_BELGIUM = 32;
        public const int TWCY_BELIZE = 501;
        public const int TWCY_BENIN = 229;
        public const int TWCY_BERMUDA = 8094;
        public const int TWCY_BHUTAN = 1003;
        public const int TWCY_BOLIVIA = 591;
        public const int TWCY_BOTSWANA = 267;
        public const int TWCY_BRITAIN = 6;
        public const int TWCY_BRITVIRGINIS = 8095;
        public const int TWCY_BRAZIL = 55;
        public const int TWCY_BRUNEI = 673;
        public const int TWCY_BULGARIA = 359;
        public const int TWCY_BURKINAFASO = 1004;
        public const int TWCY_BURMA = 1005;
        public const int TWCY_BURUNDI = 1006;
        public const int TWCY_CAMAROON = 237;
        public const int TWCY_CANADA = 2;
        public const int TWCY_CAPEVERDEIS = 238;
        public const int TWCY_CAYMANIS = 8096;
        public const int TWCY_CENTRALAFREP = 1007;
        public const int TWCY_CHAD = 1008;
        public const int TWCY_CHILE = 56;
        public const int TWCY_CHINA = 86;
        public const int TWCY_CHRISTMASIS = 1009;
        public const int TWCY_COCOSIS = 1009;
        public const int TWCY_COLOMBIA = 57;
        public const int TWCY_COMOROS = 1010;
        public const int TWCY_CONGO = 1011;
        public const int TWCY_COOKIS = 1012;
        public const int TWCY_COSTARICA = 506;
        public const int TWCY_CUBA = 005;
        public const int TWCY_CYPRUS = 357;
        public const int TWCY_CZECHOSLOVAKIA = 42;
        public const int TWCY_DENMARK = 45;
        public const int TWCY_DJIBOUTI = 1013;
        public const int TWCY_DOMINICA = 8097;
        public const int TWCY_DOMINCANREP = 8098;
        public const int TWCY_EASTERIS = 1014;
        public const int TWCY_ECUADOR = 593;
        public const int TWCY_EGYPT = 20;
        public const int TWCY_ELSALVADOR = 503;
        public const int TWCY_EQGUINEA = 1015;
        public const int TWCY_ETHIOPIA = 251;
        public const int TWCY_FALKLANDIS = 1016;
        public const int TWCY_FAEROEIS = 298;
        public const int TWCY_FIJIISLANDS = 679;
        public const int TWCY_FINLAND = 358;
        public const int TWCY_FRANCE = 33;
        public const int TWCY_FRANTILLES = 596;
        public const int TWCY_FRGUIANA = 594;
        public const int TWCY_FRPOLYNEISA = 689;
        public const int TWCY_FUTANAIS = 1043;
        public const int TWCY_GABON = 241;
        public const int TWCY_GAMBIA = 220;
        public const int TWCY_GERMANY = 49;
        public const int TWCY_GHANA = 233;
        public const int TWCY_GIBRALTER = 350;
        public const int TWCY_GREECE = 30;
        public const int TWCY_GREENLAND = 299;
        public const int TWCY_GRENADA = 8099;
        public const int TWCY_GRENEDINES = 8015;
        public const int TWCY_GUADELOUPE = 590;
        public const int TWCY_GUAM = 671;
        public const int TWCY_GUANTANAMOBAY = 5399;
        public const int TWCY_GUATEMALA = 502;
        public const int TWCY_GUINEA = 224;
        public const int TWCY_GUINEABISSAU = 1017;
        public const int TWCY_GUYANA = 592;
        public const int TWCY_HAITI = 509;
        public const int TWCY_HONDURAS = 504;
        public const int TWCY_HONGKONG = 852;
        public const int TWCY_HUNGARY = 36;
        public const int TWCY_ICELAND = 354;
        public const int TWCY_INDIA = 91;
        public const int TWCY_INDONESIA = 62;
        public const int TWCY_IRAN = 98;
        public const int TWCY_IRAQ = 964;
        public const int TWCY_IRELAND = 353;
        public const int TWCY_ISRAEL = 972;
        public const int TWCY_ITALY = 39;
        public const int TWCY_IVORYCOAST = 225;
        public const int TWCY_JAMAICA = 8010;
        public const int TWCY_JAPAN = 81;
        public const int TWCY_JORDAN = 962;
        public const int TWCY_KENYA = 254;
        public const int TWCY_KIRIBATI = 1018;
        public const int TWCY_KOREA = 82;
        public const int TWCY_KUWAIT = 965;
        public const int TWCY_LAOS = 1019;
        public const int TWCY_LEBANON = 1020;
        public const int TWCY_LIBERIA = 231;
        public const int TWCY_LIBYA = 218;
        public const int TWCY_LIECHTENSTEIN = 41;
        public const int TWCY_LUXENBOURG = 352;
        public const int TWCY_MACAO = 853;
        public const int TWCY_MADAGASCAR = 1021;
        public const int TWCY_MALAWI = 265;
        public const int TWCY_MALAYSIA = 60;
        public const int TWCY_MALDIVES = 960;
        public const int TWCY_MALI = 1022;
        public const int TWCY_MALTA = 356;
        public const int TWCY_MARSHALLIS = 692;
        public const int TWCY_MAURITANIA = 1023;
        public const int TWCY_MAURITIUS = 230;
        public const int TWCY_MEXICO = 3;
        public const int TWCY_MICRONESIA = 691;
        public const int TWCY_MIQUELON = 508;
        public const int TWCY_MONACO = 33;
        public const int TWCY_MONGOLIA = 1024;
        public const int TWCY_MONTSERRAT = 8011;
        public const int TWCY_MOROCCO = 212;
        public const int TWCY_MOZAMBIQUE = 1025;
        public const int TWCY_NAMIBIA = 264;
        public const int TWCY_NAURU = 1026;
        public const int TWCY_NEPAL = 977;
        public const int TWCY_NETHERLANDS = 31;
        public const int TWCY_NETHANTILLES = 599;
        public const int TWCY_NEVIS = 8012;
        public const int TWCY_NEWCALEDONIA = 687;
        public const int TWCY_NEWZEALAND = 64;
        public const int TWCY_NICARAGUA = 505;
        public const int TWCY_NIGER = 227;
        public const int TWCY_NIGERIA = 234;
        public const int TWCY_NIUE = 1027;
        public const int TWCY_NORFOLKI = 1028;
        public const int TWCY_NORWAY = 47;
        public const int TWCY_OMAN = 968;
        public const int TWCY_PAKISTAN = 92;
        public const int TWCY_PALAU = 1029;
        public const int TWCY_PANAMA = 507;
        public const int TWCY_PARAGUAY = 595;
        public const int TWCY_PERU = 51;
        public const int TWCY_PHILLIPPINES = 63;
        public const int TWCY_PITCAIRNIS = 1030;
        public const int TWCY_PNEWGUINEA = 675;
        public const int TWCY_POLAND = 48;
        public const int TWCY_PORTUGAL = 351;
        public const int TWCY_QATAR = 974;
        public const int TWCY_REUNIONI = 1031;
        public const int TWCY_ROMANIA = 40;
        public const int TWCY_RWANDA = 250;
        public const int TWCY_SAIPAN = 670;
        public const int TWCY_SANMARINO = 39;
        public const int TWCY_SAOTOME = 1033;
        public const int TWCY_SAUDIARABIA = 966;
        public const int TWCY_SENEGAL = 221;
        public const int TWCY_SEYCHELLESIS = 1034;
        public const int TWCY_SIERRALEONE = 1035;
        public const int TWCY_SINGAPORE = 65;
        public const int TWCY_SOLOMONIS = 1036;
        public const int TWCY_SOMALI = 1037;
        public const int TWCY_SOUTHAFRICA = 27;
        public const int TWCY_SPAIN = 34;
        public const int TWCY_SRILANKA = 94;
        public const int TWCY_STHELENA = 1032;
        public const int TWCY_STKITTS = 8013;
        public const int TWCY_STLUCIA = 8014;
        public const int TWCY_STPIERRE = 508;
        public const int TWCY_STVINCENT = 8015;
        public const int TWCY_SUDAN = 1038;
        public const int TWCY_SURINAME = 597;
        public const int TWCY_SWAZILAND = 268;
        public const int TWCY_SWEDEN = 46;
        public const int TWCY_SWITZERLAND = 41;
        public const int TWCY_SYRIA = 1039;
        public const int TWCY_TAIWAN = 886;
        public const int TWCY_TANZANIA = 255;
        public const int TWCY_THAILAND = 66;
        public const int TWCY_TOBAGO = 8016;
        public const int TWCY_TOGO = 228;
        public const int TWCY_TONGAIS = 676;
        public const int TWCY_TRINIDAD = 8016;
        public const int TWCY_TUNISIA = 216;
        public const int TWCY_TURKEY = 90;
        public const int TWCY_TURKSCAICOS = 8017;
        public const int TWCY_TUVALU = 1040;
        public const int TWCY_UGANDA = 256;
        public const int TWCY_USSR = 7;
        public const int TWCY_UAEMIRATES = 971;
        public const int TWCY_UNITEDKINGDOM = 44;
        public const int TWCY_USA = 1;
        public const int TWCY_URUGUAY = 598;
        public const int TWCY_VANUATU = 1041;
        public const int TWCY_VATICANCITY = 39;
        public const int TWCY_VENEZUELA = 58;
        public const int TWCY_WAKE = 1042;
        public const int TWCY_WALLISIS = 1043;
        public const int TWCY_WESTERNSAHARA = 1044;
        public const int TWCY_WESTERNSAMOA = 1045;
        public const int TWCY_YEMEN = 1046;
        public const int TWCY_YUGOSLAVIA = 38;
        public const int TWCY_ZAIRE = 243;
        public const int TWCY_ZAMBIA = 260;
        public const int TWCY_ZIMBABWE = 263;
        public const int TWCY_ALBANIA = 355;
        public const int TWCY_ARMENIA = 374;
        public const int TWCY_AZERBAIJAN = 994;
        public const int TWCY_BELARUS = 375;
        public const int TWCY_BOSNIAHERZGO = 387;
        public const int TWCY_CAMBODIA = 855;
        public const int TWCY_CROATIA = 385;
        public const int TWCY_CZECHREPUBLIC = 420;
        public const int TWCY_DIEGOGARCIA = 246;
        public const int TWCY_ERITREA = 291;
        public const int TWCY_ESTONIA = 372;
        public const int TWCY_GEORGIA = 995;
        public const int TWCY_LATVIA = 371;
        public const int TWCY_LESOTHO = 266;
        public const int TWCY_LITHUANIA = 370;
        public const int TWCY_MACEDONIA = 389;
        public const int TWCY_MAYOTTEIS = 269;
        public const int TWCY_MOLDOVA = 373;
        public const int TWCY_MYANMAR = 95;
        public const int TWCY_NORTHKOREA = 850;
        public const int TWCY_PUERTORICO = 787;
        public const int TWCY_RUSSIA = 7;
        public const int TWCY_SERBIA = 381;
        public const int TWCY_SLOVAKIA = 421;
        public const int TWCY_SLOVENIA = 386;
        public const int TWCY_SOUTHKOREA = 82;
        public const int TWCY_UKRAINE = 380;
        public const int TWCY_USVIRGINIS = 340;
        public const int TWCY_VIETNAM = 84;

        /****************************************************************************
         * Language Constants                                                       *
         ****************************************************************************/
        public const int TWLG_USERLOCALE = -1;
        public const int TWLG_DAN = 0;
        public const int TWLG_DUT = 1;
        public const int TWLG_ENG = 2;
        public const int TWLG_FCF = 3;
        public const int TWLG_FIN = 4;
        public const int TWLG_FRN = 5;
        public const int TWLG_GER = 6;
        public const int TWLG_ICE = 7;
        public const int TWLG_ITN = 8;
        public const int TWLG_NOR = 9;
        public const int TWLG_POR = 10;
        public const int TWLG_SPA = 11;
        public const int TWLG_SWE = 12;
        public const int TWLG_USA = 13;
        public const int TWLG_AFRIKAANS = 14;
        public const int TWLG_ALBANIA = 15;
        public const int TWLG_ARABIC = 16;
        public const int TWLG_ARABIC_ALGERIA = 17;
        public const int TWLG_ARABIC_BAHRAIN = 18;
        public const int TWLG_ARABIC_EGYPT = 19;
        public const int TWLG_ARABIC_IRAQ = 20;
        public const int TWLG_ARABIC_JORDAN = 21;
        public const int TWLG_ARABIC_KUWAIT = 22;
        public const int TWLG_ARABIC_LEBANON = 23;
        public const int TWLG_ARABIC_LIBYA = 24;
        public const int TWLG_ARABIC_MOROCCO = 25;
        public const int TWLG_ARABIC_OMAN = 26;
        public const int TWLG_ARABIC_QATAR = 27;
        public const int TWLG_ARABIC_SAUDIARABIA = 28;
        public const int TWLG_ARABIC_SYRIA = 29;
        public const int TWLG_ARABIC_TUNISIA = 30;
        public const int TWLG_ARABIC_UAE = 31;
        public const int TWLG_ARABIC_YEMEN = 32;
        public const int TWLG_BASQUE = 33;
        public const int TWLG_BYELORUSSIAN = 34;
        public const int TWLG_BULGARIAN = 35;
        public const int TWLG_CATALAN = 36;
        public const int TWLG_CHINESE = 37;
        public const int TWLG_CHINESE_HONGKONG = 38;
        public const int TWLG_CHINESE_PRC = 39;
        public const int TWLG_CHINESE_SINGAPORE = 40;
        public const int TWLG_CHINESE_SIMPLIFIED = 41;
        public const int TWLG_CHINESE_TAIWAN = 42;
        public const int TWLG_CHINESE_TRADITIONAL = 43;
        public const int TWLG_CROATIA = 44;
        public const int TWLG_CZECH = 45;
        public const int TWLG_DANISH = TWLG_DAN;
        public const int TWLG_DUTCH = TWLG_DUT;
        public const int TWLG_DUTCH_BELGIAN = 46;
        public const int TWLG_ENGLISH = TWLG_ENG;
        public const int TWLG_ENGLISH_AUSTRALIAN = 47;
        public const int TWLG_ENGLISH_CANADIAN = 48;
        public const int TWLG_ENGLISH_IRELAND = 49;
        public const int TWLG_ENGLISH_NEWZEALAND = 50;
        public const int TWLG_ENGLISH_SOUTHAFRICA = 51;
        public const int TWLG_ENGLISH_UK = 52;
        public const int TWLG_ENGLISH_USA = TWLG_USA;
        public const int TWLG_ESTONIAN = 53;
        public const int TWLG_FAEROESE = 54;
        public const int TWLG_FARSI = 55;
        public const int TWLG_FINNISH = TWLG_FIN;
        public const int TWLG_FRENCH = TWLG_FRN;
        public const int TWLG_FRENCH_BELGIAN = 56;
        public const int TWLG_FRENCH_CANADIAN = TWLG_FCF;
        public const int TWLG_FRENCH_LUXEMBOURG = 57;
        public const int TWLG_FRENCH_SWISS = 58;
        public const int TWLG_GERMAN = TWLG_GER;
        public const int TWLG_GERMAN_AUSTRIAN = 59;
        public const int TWLG_GERMAN_LUXEMBOURG = 60;
        public const int TWLG_GERMAN_LIECHTENSTEIN = 61;
        public const int TWLG_GERMAN_SWISS = 62;
        public const int TWLG_GREEK = 63;
        public const int TWLG_HEBREW = 64;
        public const int TWLG_HUNGARIAN = 65;
        public const int TWLG_ICELANDIC = TWLG_ICE;
        public const int TWLG_INDONESIAN = 66;
        public const int TWLG_ITALIAN = TWLG_ITN;
        public const int TWLG_ITALIAN_SWISS = 67;
        public const int TWLG_JAPANESE = 68;
        public const int TWLG_KOREAN = 69;
        public const int TWLG_KOREAN_JOHAB = 70;
        public const int TWLG_LATVIAN = 71;
        public const int TWLG_LITHUANIAN = 72;
        public const int TWLG_NORWEGIAN = TWLG_NOR;
        public const int TWLG_NORWEGIAN_BOKMAL = 73;
        public const int TWLG_NORWEGIAN_NYNORSK = 74;
        public const int TWLG_POLISH = 75;
        public const int TWLG_PORTUGUESE = TWLG_POR;
        public const int TWLG_PORTUGUESE_BRAZIL = 76;
        public const int TWLG_ROMANIAN = 77;
        public const int TWLG_RUSSIAN = 78;
        public const int TWLG_SERBIAN_LATIN = 79;
        public const int TWLG_SLOVAK = 80;
        public const int TWLG_SLOVENIAN = 81;
        public const int TWLG_SPANISH = TWLG_SPA;
        public const int TWLG_SPANISH_MEXICAN = 82;
        public const int TWLG_SPANISH_MODERN = 83;
        public const int TWLG_SWEDISH = TWLG_SWE;
        public const int TWLG_THAI = 84;
        public const int TWLG_TURKISH = 85;
        public const int TWLG_UKRANIAN = 86;
        public const int TWLG_ASSAMESE = 87;
        public const int TWLG_BENGALI = 88;
        public const int TWLG_BIHARI = 89;
        public const int TWLG_BODO = 90;
        public const int TWLG_DOGRI = 91;
        public const int TWLG_GUJARATI = 92;
        public const int TWLG_HARYANVI = 93;
        public const int TWLG_HINDI = 94;
        public const int TWLG_KANNADA = 95;
        public const int TWLG_KASHMIRI = 96;
        public const int TWLG_MALAYALAM = 97;
        public const int TWLG_MARATHI = 98;
        public const int TWLG_MARWARI = 99;
        public const int TWLG_MEGHALAYAN = 100;
        public const int TWLG_MIZO = 101;
        public const int TWLG_NAGA = 102;
        public const int TWLG_ORISSI = 103;
        public const int TWLG_PUNJABI = 104;
        public const int TWLG_PUSHTU = 105;
        public const int TWLG_SERBIAN_CYRILLIC = 106;
        public const int TWLG_SIKKIMI = 107;
        public const int TWLG_SWEDISH_FINLAND = 108;
        public const int TWLG_TAMIL = 109;
        public const int TWLG_TELUGU = 110;
        public const int TWLG_TRIPURI = 111;
        public const int TWLG_URDU = 112;
        public const int TWLG_VIETNAMESE = 113;


        /// <summary>
        /// Gets the name of the cap corresponding to the given code.
        /// </summary>
        /// <param name="capCode">e.g., 0x0101</param>
        /// <returns>cap name (e.g., ICAP_PIXELTYPE) or null if not found.</returns>
        public static String getCapName(int capCode)
        {
            Dictionary<int, string> map = getMapCapCodeToName();
            return map.ContainsKey(capCode) ? map[capCode] : null;
        }

        /// <summary>
        /// Gets the code of the cap corresponding to the given name.
        /// </summary>
        /// <param name="capName">e.g., ICAP_PIXELTYPE</param>
        /// <returns>cap code (e.g., 0x0101) or -1 if not found.</returns>
        public static int getCapCode(string capName)
        {
            Dictionary<string, int> map = getMapCapNameToCode();
            return map.ContainsKey(capName) ? map[capName] : -1;
        }

        /// <summary>
        /// Gets the name of the result code.
        /// </summary>
        /// <param name="twrcCode">e.g., 0</param>
        /// <returns>Result code name (e.g., TWRC_SUCCESS) or null if not found.</returns>
        public static String getTwrcName(int twrcCode)
        {
            Dictionary<int, string> map = getMapTwrcCodeToName();
            return map.ContainsKey(twrcCode) ? map[twrcCode] : null;
        }

        /// <summary>
        /// Gets the result code corresponding to the given name.
        /// </summary>
        /// <param name="twrcName">e.g., TWRC_SUCCESS</param>
        /// <returns>TWEI code (e.g., 0) or -1 if not found.</returns>
        public static int getTwrcCode(String twrcName)
        {
            if (twrcName == null)
            {
                return -1;
            }
            Dictionary<string, int> map = getMapTwrcNameToCode();
            return map.ContainsKey(twrcName) ? map[twrcName] : -1;
        }

        /// <summary>
        /// Gets the name of the TWEI attribute corresponding to the given code.
        /// </summary>
        /// <param name="tweiCode">e.g., 0x1200</param>
        /// <returns>TWEI name (e.g., TWEI_BARCODEX) or null if not found.</returns>
        public static String getTweiName(int tweiCode)
        {
            Dictionary<int, string> map = getMapTweiCodeToName();
            return map.ContainsKey(tweiCode) ? map[tweiCode] : null;
        }

        /// <summary>
        /// Gets the code of the TWEI attribute corresponding to the given name.
        /// </summary>
        /// <param name="tweiName">e.g., TWEI_BARCODEX</param>
        /// <returns>TWEI code (e.g., 0x1200) or -1 if not found.</returns>
        public static int getTweiCode(String tweiName)
        {
            Dictionary<string, int> map = getMapTweiNameToCode();
            return map.ContainsKey(tweiName) ? map[tweiName] : -1;
        }

        /// <summary>
        /// Returns the integer value of any TW* constant.
        /// </summary>
        /// <param name="contantName"></param>
        /// <returns></returns>
        public static int getConstantValue(String contantName)
        {
            Dictionary<string, int> map = getMapConstantNameToIntValue();
            return map.ContainsKey(contantName) ? map[contantName] : -1;
        }


        private static Dictionary<string, int> mapCapNameToCode;

        private static Dictionary<string, int> getMapCapNameToCode()
        {
            if (mapCapNameToCode != null)
            {
                return mapCapNameToCode;
            }

            Dictionary<string, int> map = new Dictionary<string, int>();
            map.Add("CAP_CUSTOMBASE", 0x8000); /* Base of custom capabilities */

            /* all data sources are REQUIRED to support these caps */
            map.Add("CAP_XFERCOUNT", 0x0001);

            /* image data sources are REQUIRED to support these caps */
            map.Add("ICAP_COMPRESSION", 0x0100);
            map.Add("ICAP_PIXELTYPE", 0x0101);
            map.Add("ICAP_UNITS", 0x0102);
            map.Add("ICAP_XFERMECH", 0x0103);

            /* all data sources MAY support these caps */
            map.Add("CAP_AUTHOR", 0x1000);
            map.Add("CAP_CAPTION", 0x1001);
            map.Add("CAP_FEEDERENABLED", 0x1002);
            map.Add("CAP_FEEDERLOADED", 0x1003);
            map.Add("CAP_TIMEDATE", 0x1004);
            map.Add("CAP_SUPPORTEDCAPS", 0x1005);
            map.Add("CAP_EXTENDEDCAPS", 0x1006);
            map.Add("CAP_AUTOFEED", 0x1007);
            map.Add("CAP_CLEARPAGE", 0x1008);
            map.Add("CAP_FEEDPAGE", 0x1009);
            map.Add("CAP_REWINDPAGE", 0x100a);
            map.Add("CAP_INDICATORS", 0x100b);
            map.Add("CAP_PAPERDETECTABLE", 0x100d);
            map.Add("CAP_UICONTROLLABLE", 0x100e);
            map.Add("CAP_DEVICEONLINE", 0x100f);
            map.Add("CAP_AUTOSCAN", 0x1010);
            map.Add("CAP_THUMBNAILSENABLED", 0x1011);
            map.Add("CAP_DUPLEX", 0x1012);
            map.Add("CAP_DUPLEXENABLED", 0x1013);
            map.Add("CAP_ENABLEDSUIONLY", 0x1014);
            map.Add("CAP_CUSTOMDSDATA", 0x1015);
            map.Add("CAP_ENDORSER", 0x1016);
            map.Add("CAP_JOBCONTROL", 0x1017);
            map.Add("CAP_ALARMS", 0x1018);
            map.Add("CAP_ALARMVOLUME", 0x1019);
            map.Add("CAP_AUTOMATICCAPTURE", 0x101a);
            map.Add("CAP_TIMEBEFOREFIRSTCAPTURE", 0x101b);
            map.Add("CAP_TIMEBETWEENCAPTURES", 0x101c);
            map.Add("CAP_CLEARBUFFERS", 0x101d);
            map.Add("CAP_MAXBATCHBUFFERS", 0x101e);
            map.Add("CAP_DEVICETIMEDATE", 0x101f);
            map.Add("CAP_POWERSUPPLY", 0x1020);
            map.Add("CAP_CAMERAPREVIEWUI", 0x1021);
            map.Add("CAP_DEVICEEVENT", 0x1022);
            map.Add("CAP_SERIALNUMBER", 0x1024);
            map.Add("CAP_PRINTER", 0x1026);
            map.Add("CAP_PRINTERENABLED", 0x1027);
            map.Add("CAP_PRINTERINDEX", 0x1028);
            map.Add("CAP_PRINTERMODE", 0x1029);
            map.Add("CAP_PRINTERSTRING", 0x102a);
            map.Add("CAP_PRINTERSUFFIX", 0x102b);
            map.Add("CAP_LANGUAGE", 0x102c);
            map.Add("CAP_FEEDERALIGNMENT", 0x102d);
            map.Add("CAP_FEEDERORDER", 0x102e);
            map.Add("CAP_REACQUIREALLOWED", 0x1030);
            map.Add("CAP_BATTERYMINUTES", 0x1032);
            map.Add("CAP_BATTERYPERCENTAGE", 0x1033);
            map.Add("CAP_CAMERASIDE", 0x1034);
            map.Add("CAP_SEGMENTED", 0x1035);
            map.Add("CAP_CAMERAENABLED", 0x1036);
            map.Add("CAP_CAMERAORDER", 0x1037);
            map.Add("CAP_MICRENABLED", 0x1038);
            map.Add("CAP_FEEDERPREP", 0x1039);
            map.Add("CAP_FEEDERPOCKET", 0x103a);
            map.Add("CAP_AUTOMATICSENSEMEDIUM", 0x103b);
            map.Add("CAP_CUSTOMINTERFACEGUID", 0x103c);
            map.Add("CAP_SUPPORTEDCAPSSEGMENTUNIQUE", 0x103d);
            map.Add("CAP_SUPPORTEDDATS", 0x103e);
            map.Add("CAP_DOUBLEFEEDDETECTION", 0x103f);
            map.Add("CAP_DOUBLEFEEDDETECTIONLENGTH", 0x1040);
            map.Add("CAP_DOUBLEFEEDDETECTIONSENSITIVITY", 0x1041);
            map.Add("CAP_DOUBLEFEEDDETECTIONRESPONSE", 0x1042);
            map.Add("CAP_PAPERHANDLING", 0x1043);
            map.Add("CAP_INDICATORSMODE", 0x1044);
            map.Add("CAP_PRINTERVERTICALOFFSET", 0x1045);
            map.Add("CAP_POWERSAVETIME", 0x1046);
            map.Add("CAP_PRINTERCHARROTATION", 0x1047);
            map.Add("CAP_PRINTERFONTSTYLE", 0x1048);
            map.Add("CAP_PRINTERINDEXLEADCHAR", 0x1049);
            map.Add("CAP_PRINTERINDEXMAXVALUE", 0x104A);
            map.Add("CAP_PRINTERINDEXNUMDIGITS", 0x104B);
            map.Add("CAP_PRINTERINDEXSTEP", 0x104C);
            map.Add("CAP_PRINTERINDEXTRIGGER", 0x104D);
            map.Add("CAP_PRINTERSTRINGPREVIEW", 0x104E);

            /* image data sources MAY support these caps */
            map.Add("ICAP_AUTOBRIGHT", 0x1100);
            map.Add("ICAP_BRIGHTNESS", 0x1101);
            map.Add("ICAP_CONTRAST", 0x1103);
            map.Add("ICAP_CUSTHALFTONE", 0x1104);
            map.Add("ICAP_EXPOSURETIME", 0x1105);
            map.Add("ICAP_FILTER", 0x1106);
            map.Add("ICAP_FLASHUSED", 0x1107);
            map.Add("ICAP_GAMMA", 0x1108);
            map.Add("ICAP_HALFTONES", 0x1109);
            map.Add("ICAP_HIGHLIGHT", 0x110a);
            map.Add("ICAP_IMAGEFILEFORMAT", 0x110c);
            map.Add("ICAP_LAMPSTATE", 0x110d);
            map.Add("ICAP_LIGHTSOURCE", 0x110e);
            map.Add("ICAP_ORIENTATION", 0x1110);
            map.Add("ICAP_PHYSICALWIDTH", 0x1111);
            map.Add("ICAP_PHYSICALHEIGHT", 0x1112);
            map.Add("ICAP_SHADOW", 0x1113);
            map.Add("ICAP_FRAMES", 0x1114);
            map.Add("ICAP_XNATIVERESOLUTION", 0x1116);
            map.Add("ICAP_YNATIVERESOLUTION", 0x1117);
            map.Add("ICAP_XRESOLUTION", 0x1118);
            map.Add("ICAP_YRESOLUTION", 0x1119);
            map.Add("ICAP_MAXFRAMES", 0x111a);
            map.Add("ICAP_TILES", 0x111b);
            map.Add("ICAP_BITORDER", 0x111c);
            map.Add("ICAP_CCITTKFACTOR", 0x111d);
            map.Add("ICAP_LIGHTPATH", 0x111e);
            map.Add("ICAP_PIXELFLAVOR", 0x111f);
            map.Add("ICAP_PLANARCHUNKY", 0x1120);
            map.Add("ICAP_ROTATION", 0x1121);
            map.Add("ICAP_SUPPORTEDSIZES", 0x1122);
            map.Add("ICAP_THRESHOLD", 0x1123);
            map.Add("ICAP_XSCALING", 0x1124);
            map.Add("ICAP_YSCALING", 0x1125);
            map.Add("ICAP_BITORDERCODES", 0x1126);
            map.Add("ICAP_PIXELFLAVORCODES", 0x1127);
            map.Add("ICAP_JPEGPIXELTYPE", 0x1128);
            map.Add("ICAP_TIMEFILL", 0x112a);
            map.Add("ICAP_BITDEPTH", 0x112b);
            map.Add("ICAP_BITDEPTHREDUCTION", 0x112c);
            map.Add("ICAP_UNDEFINEDIMAGESIZE", 0x112d);
            map.Add("ICAP_IMAGEDATASET", 0x112e);
            map.Add("ICAP_EXTIMAGEINFO", 0x112f);
            map.Add("ICAP_MINIMUMHEIGHT", 0x1130);
            map.Add("ICAP_MINIMUMWIDTH", 0x1131);
            map.Add("ICAP_AUTODISCARDBLANKPAGES", 0x1134);
            map.Add("ICAP_FLIPROTATION", 0x1136);
            map.Add("ICAP_BARCODEDETECTIONENABLED", 0x1137);
            map.Add("ICAP_SUPPORTEDBARCODETYPES", 0x1138);
            map.Add("ICAP_BARCODEMAXSEARCHPRIORITIES", 0x1139);
            map.Add("ICAP_BARCODESEARCHPRIORITIES", 0x113a);
            map.Add("ICAP_BARCODESEARCHMODE", 0x113b);
            map.Add("ICAP_BARCODEMAXRETRIES", 0x113c);
            map.Add("ICAP_BARCODETIMEOUT", 0x113d);
            map.Add("ICAP_ZOOMFACTOR", 0x113e);
            map.Add("ICAP_PATCHCODEDETECTIONENABLED", 0x113f);
            map.Add("ICAP_SUPPORTEDPATCHCODETYPES", 0x1140);
            map.Add("ICAP_PATCHCODEMAXSEARCHPRIORITIES", 0x1141);
            map.Add("ICAP_PATCHCODESEARCHPRIORITIES", 0x1142);
            map.Add("ICAP_PATCHCODESEARCHMODE", 0x1143);
            map.Add("ICAP_PATCHCODEMAXRETRIES", 0x1144);
            map.Add("ICAP_PATCHCODETIMEOUT", 0x1145);
            map.Add("ICAP_FLASHUSED2", 0x1146);
            map.Add("ICAP_IMAGEFILTER", 0x1147);
            map.Add("ICAP_NOISEFILTER", 0x1148);
            map.Add("ICAP_OVERSCAN", 0x1149);
            map.Add("ICAP_AUTOMATICBORDERDETECTION", 0x1150);
            map.Add("ICAP_AUTOMATICDESKEW", 0x1151);
            map.Add("ICAP_AUTOMATICROTATE", 0x1152);
            map.Add("ICAP_JPEGQUALITY", 0x1153);
            map.Add("ICAP_FEEDERTYPE", 0x1154);
            map.Add("ICAP_ICCPROFILE", 0x1155);
            map.Add("ICAP_AUTOSIZE", 0x1156);
            map.Add("ICAP_AUTOMATICCROPUSESFRAME", 0x1157);
            map.Add("ICAP_AUTOMATICLENGTHDETECTION", 0x1158);
            map.Add("ICAP_AUTOMATICCOLORENABLED", 0x1159);
            map.Add("ICAP_AUTOMATICCOLORNONCOLORPIXELTYPE", 0x115a);
            map.Add("ICAP_COLORMANAGEMENTENABLED", 0x115b);
            map.Add("ICAP_IMAGEMERGE", 0x115c);
            map.Add("ICAP_IMAGEMERGEHEIGHTTHRESHOLD", 0x115d);
            map.Add("ICAP_SUPPORTEDEXTIMAGEINFO", 0x115e);
            map.Add("ICAP_FILMTYPE", 0x115f);
            map.Add("ICAP_MIRROR", 0x1160);
            map.Add("ICAP_JPEGSUBSAMPLING", 0x1161);

            map.Add("CAP_SUPPORTEDCAPSEXT", 0x100c);
            map.Add("CAP_PAGEMULTIPLEACQUIRE", 0x1023);
            map.Add("CAP_PAPERBINDING", 0x102f);
            map.Add("CAP_PASSTHRU", 0x1031);
            map.Add("CAP_POWERDOWNTIME", 0x1034);

            mapCapNameToCode = map;
            return mapCapNameToCode;
        }

        private static Dictionary<int, string> mapCapCodeToName;

        private static Dictionary<int, string> getMapCapCodeToName()
        {
            if (mapCapCodeToName != null)
            {
                return mapCapCodeToName;
            }

            Dictionary<int, string> map = new Dictionary<int, string>();
            map.Add(0x8000, "CAP_CUSTOMBASE"); /* Base of custom capabilities */

            /* all data sources are REQUIRED to support these caps */
            map.Add(0x0001, "CAP_XFERCOUNT");

            /* image data sources are REQUIRED to support these caps */
            map.Add(0x0100, "ICAP_COMPRESSION");
            map.Add(0x0101, "ICAP_PIXELTYPE");
            map.Add(0x0102, "ICAP_UNITS");
            map.Add(0x0103, "ICAP_XFERMECH");

            /* all data sources MAY support these caps */
            map.Add(0x1000, "CAP_AUTHOR");
            map.Add(0x1001, "CAP_CAPTION");
            map.Add(0x1002, "CAP_FEEDERENABLED");
            map.Add(0x1003, "CAP_FEEDERLOADED");
            map.Add(0x1004, "CAP_TIMEDATE");
            map.Add(0x1005, "CAP_SUPPORTEDCAPS");
            map.Add(0x1006, "CAP_EXTENDEDCAPS");
            map.Add(0x1007, "CAP_AUTOFEED");
            map.Add(0x1008, "CAP_CLEARPAGE");
            map.Add(0x1009, "CAP_FEEDPAGE");
            map.Add(0x100a, "CAP_REWINDPAGE");
            map.Add(0x100b, "CAP_INDICATORS");
            map.Add(0x100d, "CAP_PAPERDETECTABLE");
            map.Add(0x100e, "CAP_UICONTROLLABLE");
            map.Add(0x100f, "CAP_DEVICEONLINE");
            map.Add(0x1010, "CAP_AUTOSCAN");
            map.Add(0x1011, "CAP_THUMBNAILSENABLED");
            map.Add(0x1012, "CAP_DUPLEX");
            map.Add(0x1013, "CAP_DUPLEXENABLED");
            map.Add(0x1014, "CAP_ENABLEDSUIONLY");
            map.Add(0x1015, "CAP_CUSTOMDSDATA");
            map.Add(0x1016, "CAP_ENDORSER");
            map.Add(0x1017, "CAP_JOBCONTROL");
            map.Add(0x1018, "CAP_ALARMS");
            map.Add(0x1019, "CAP_ALARMVOLUME");
            map.Add(0x101a, "CAP_AUTOMATICCAPTURE");
            map.Add(0x101b, "CAP_TIMEBEFOREFIRSTCAPTURE");
            map.Add(0x101c, "CAP_TIMEBETWEENCAPTURES");
            map.Add(0x101d, "CAP_CLEARBUFFERS");
            map.Add(0x101e, "CAP_MAXBATCHBUFFERS");
            map.Add(0x101f, "CAP_DEVICETIMEDATE");
            map.Add(0x1020, "CAP_POWERSUPPLY");
            map.Add(0x1021, "CAP_CAMERAPREVIEWUI");
            map.Add(0x1022, "CAP_DEVICEEVENT");
            map.Add(0x1024, "CAP_SERIALNUMBER");
            map.Add(0x1026, "CAP_PRINTER");
            map.Add(0x1027, "CAP_PRINTERENABLED");
            map.Add(0x1028, "CAP_PRINTERINDEX");
            map.Add(0x1029, "CAP_PRINTERMODE");
            map.Add(0x102a, "CAP_PRINTERSTRING");
            map.Add(0x102b, "CAP_PRINTERSUFFIX");
            map.Add(0x102c, "CAP_LANGUAGE");
            map.Add(0x102d, "CAP_FEEDERALIGNMENT");
            map.Add(0x102e, "CAP_FEEDERORDER");
            map.Add(0x1030, "CAP_REACQUIREALLOWED");
            map.Add(0x1032, "CAP_BATTERYMINUTES");
            map.Add(0x1033, "CAP_BATTERYPERCENTAGE");
            map.Add(0x1034, "CAP_CAMERASIDE");
            map.Add(0x1035, "CAP_SEGMENTED");
            map.Add(0x1036, "CAP_CAMERAENABLED");
            map.Add(0x1037, "CAP_CAMERAORDER");
            map.Add(0x1038, "CAP_MICRENABLED");
            map.Add(0x1039, "CAP_FEEDERPREP");
            map.Add(0x103a, "CAP_FEEDERPOCKET");
            map.Add(0x103b, "CAP_AUTOMATICSENSEMEDIUM");
            map.Add(0x103c, "CAP_CUSTOMINTERFACEGUID");
            map.Add(0x103d, "CAP_SUPPORTEDCAPSSEGMENTUNIQUE");
            map.Add(0x103e, "CAP_SUPPORTEDDATS");
            map.Add(0x103f, "CAP_DOUBLEFEEDDETECTION");
            map.Add(0x1040, "CAP_DOUBLEFEEDDETECTIONLENGTH");
            map.Add(0x1041, "CAP_DOUBLEFEEDDETECTIONSENSITIVITY");
            map.Add(0x1042, "CAP_DOUBLEFEEDDETECTIONRESPONSE");
            map.Add(0x1043, "CAP_PAPERHANDLING");
            map.Add(0x1044, "CAP_INDICATORSMODE");
            map.Add(0x1045, "CAP_PRINTERVERTICALOFFSET");
            map.Add(0x1046, "CAP_POWERSAVETIME");
            map.Add(0x1047, "CAP_PRINTERCHARROTATION");
            map.Add(0x1048, "CAP_PRINTERFONTSTYLE");
            map.Add(0x1049, "CAP_PRINTERINDEXLEADCHAR");
            map.Add(0x104A, "CAP_PRINTERINDEXMAXVALUE");
            map.Add(0x104B, "CAP_PRINTERINDEXNUMDIGITS");
            map.Add(0x104C, "CAP_PRINTERINDEXSTEP");
            map.Add(0x104D, "CAP_PRINTERINDEXTRIGGER");
            map.Add(0x104E, "CAP_PRINTERSTRINGPREVIEW");

            /* image data sources MAY support these caps */
            map.Add(0x1100, "ICAP_AUTOBRIGHT");
            map.Add(0x1101, "ICAP_BRIGHTNESS");
            map.Add(0x1103, "ICAP_CONTRAST");
            map.Add(0x1104, "ICAP_CUSTHALFTONE");
            map.Add(0x1105, "ICAP_EXPOSURETIME");
            map.Add(0x1106, "ICAP_FILTER");
            map.Add(0x1107, "ICAP_FLASHUSED");
            map.Add(0x1108, "ICAP_GAMMA");
            map.Add(0x1109, "ICAP_HALFTONES");
            map.Add(0x110a, "ICAP_HIGHLIGHT");
            map.Add(0x110c, "ICAP_IMAGEFILEFORMAT");
            map.Add(0x110d, "ICAP_LAMPSTATE");
            map.Add(0x110e, "ICAP_LIGHTSOURCE");
            map.Add(0x1110, "ICAP_ORIENTATION");
            map.Add(0x1111, "ICAP_PHYSICALWIDTH");
            map.Add(0x1112, "ICAP_PHYSICALHEIGHT");
            map.Add(0x1113, "ICAP_SHADOW");
            map.Add(0x1114, "ICAP_FRAMES");
            map.Add(0x1116, "ICAP_XNATIVERESOLUTION");
            map.Add(0x1117, "ICAP_YNATIVERESOLUTION");
            map.Add(0x1118, "ICAP_XRESOLUTION");
            map.Add(0x1119, "ICAP_YRESOLUTION");
            map.Add(0x111a, "ICAP_MAXFRAMES");
            map.Add(0x111b, "ICAP_TILES");
            map.Add(0x111c, "ICAP_BITORDER");
            map.Add(0x111d, "ICAP_CCITTKFACTOR");
            map.Add(0x111e, "ICAP_LIGHTPATH");
            map.Add(0x111f, "ICAP_PIXELFLAVOR");
            map.Add(0x1120, "ICAP_PLANARCHUNKY");
            map.Add(0x1121, "ICAP_ROTATION");
            map.Add(0x1122, "ICAP_SUPPORTEDSIZES");
            map.Add(0x1123, "ICAP_THRESHOLD");
            map.Add(0x1124, "ICAP_XSCALING");
            map.Add(0x1125, "ICAP_YSCALING");
            map.Add(0x1126, "ICAP_BITORDERCODES");
            map.Add(0x1127, "ICAP_PIXELFLAVORCODES");
            map.Add(0x1128, "ICAP_JPEGPIXELTYPE");
            map.Add(0x112a, "ICAP_TIMEFILL");
            map.Add(0x112b, "ICAP_BITDEPTH");
            map.Add(0x112c, "ICAP_BITDEPTHREDUCTION");
            map.Add(0x112d, "ICAP_UNDEFINEDIMAGESIZE");
            map.Add(0x112e, "ICAP_IMAGEDATASET");
            map.Add(0x112f, "ICAP_EXTIMAGEINFO");
            map.Add(0x1130, "ICAP_MINIMUMHEIGHT");
            map.Add(0x1131, "ICAP_MINIMUMWIDTH");
            map.Add(0x1134, "ICAP_AUTODISCARDBLANKPAGES");
            map.Add(0x1136, "ICAP_FLIPROTATION");
            map.Add(0x1137, "ICAP_BARCODEDETECTIONENABLED");
            map.Add(0x1138, "ICAP_SUPPORTEDBARCODETYPES");
            map.Add(0x1139, "ICAP_BARCODEMAXSEARCHPRIORITIES");
            map.Add(0x113a, "ICAP_BARCODESEARCHPRIORITIES");
            map.Add(0x113b, "ICAP_BARCODESEARCHMODE");
            map.Add(0x113c, "ICAP_BARCODEMAXRETRIES");
            map.Add(0x113d, "ICAP_BARCODETIMEOUT");
            map.Add(0x113e, "ICAP_ZOOMFACTOR");
            map.Add(0x113f, "ICAP_PATCHCODEDETECTIONENABLED");
            map.Add(0x1140, "ICAP_SUPPORTEDPATCHCODETYPES");
            map.Add(0x1141, "ICAP_PATCHCODEMAXSEARCHPRIORITIES");
            map.Add(0x1142, "ICAP_PATCHCODESEARCHPRIORITIES");
            map.Add(0x1143, "ICAP_PATCHCODESEARCHMODE");
            map.Add(0x1144, "ICAP_PATCHCODEMAXRETRIES");
            map.Add(0x1145, "ICAP_PATCHCODETIMEOUT");
            map.Add(0x1146, "ICAP_FLASHUSED2");
            map.Add(0x1147, "ICAP_IMAGEFILTER");
            map.Add(0x1148, "ICAP_NOISEFILTER");
            map.Add(0x1149, "ICAP_OVERSCAN");
            map.Add(0x1150, "ICAP_AUTOMATICBORDERDETECTION");
            map.Add(0x1151, "ICAP_AUTOMATICDESKEW");
            map.Add(0x1152, "ICAP_AUTOMATICROTATE");
            map.Add(0x1153, "ICAP_JPEGQUALITY");
            map.Add(0x1154, "ICAP_FEEDERTYPE");
            map.Add(0x1155, "ICAP_ICCPROFILE");
            map.Add(0x1156, "ICAP_AUTOSIZE");
            map.Add(0x1157, "ICAP_AUTOMATICCROPUSESFRAME");
            map.Add(0x1158, "ICAP_AUTOMATICLENGTHDETECTION");
            map.Add(0x1159, "ICAP_AUTOMATICCOLORENABLED");
            map.Add(0x115a, "ICAP_AUTOMATICCOLORNONCOLORPIXELTYPE");
            map.Add(0x115b, "ICAP_COLORMANAGEMENTENABLED");
            map.Add(0x115c, "ICAP_IMAGEMERGE");
            map.Add(0x115d, "ICAP_IMAGEMERGEHEIGHTTHRESHOLD");
            map.Add(0x115e, "ICAP_SUPPORTEDEXTIMAGEINFO");
            map.Add(0x115f, "ICAP_FILMTYPE");
            map.Add(0x1160, "ICAP_MIRROR");
            map.Add(0x1161, "ICAP_JPEGSUBSAMPLING");

            map.Add(0x100c, "CAP_SUPPORTEDCAPSEXT");
            map.Add(0x1023, "CAP_PAGEMULTIPLEACQUIRE");
            map.Add(0x102f, "CAP_PAPERBINDING");
            map.Add(0x1031, "CAP_PASSTHRU");

            // #define CAP_POWERDOWNTIME 0x1034 /* Added 1.8 */ //0x1034 is reused by CAP_CAMERASIDE
            // map.Add(0x1034, "CAP_POWERDOWNTIME");

            mapCapCodeToName = map;
            return mapCapCodeToName;
        }

        private static Dictionary<int, string> mapTweiCodeToName;

        private static Dictionary<int, string> getMapTweiCodeToName()
        {
            if (mapTweiCodeToName != null)
            {
                return mapTweiCodeToName;
            }

            Dictionary<int, string> map = new Dictionary<int, string>();
            map.Add(0x1200, "TWEI_BARCODEX");
            map.Add(0x1201, "TWEI_BARCODEY");
            map.Add(0x1202, "TWEI_BARCODETEXT");
            map.Add(0x1203, "TWEI_BARCODETYPE");
            map.Add(0x1204, "TWEI_DESHADETOP");
            map.Add(0x1205, "TWEI_DESHADELEFT");
            map.Add(0x1206, "TWEI_DESHADEHEIGHT");
            map.Add(0x1207, "TWEI_DESHADEWIDTH");
            map.Add(0x1208, "TWEI_DESHADESIZE");
            map.Add(0x1209, "TWEI_SPECKLESREMOVED");
            map.Add(0x120A, "TWEI_HORZLINEXCOORD");
            map.Add(0x120B, "TWEI_HORZLINEYCOORD");
            map.Add(0x120C, "TWEI_HORZLINELENGTH");
            map.Add(0x120D, "TWEI_HORZLINETHICKNESS");
            map.Add(0x120E, "TWEI_VERTLINEXCOORD");
            map.Add(0x120F, "TWEI_VERTLINEYCOORD");
            map.Add(0x1210, "TWEI_VERTLINELENGTH");
            map.Add(0x1211, "TWEI_VERTLINETHICKNESS");
            map.Add(0x1212, "TWEI_PATCHCODE");
            map.Add(0x1213, "TWEI_ENDORSEDTEXT");
            map.Add(0x1214, "TWEI_FORMCONFIDENCE");
            map.Add(0x1215, "TWEI_FORMTEMPLATEMATCH");
            map.Add(0x1216, "TWEI_FORMTEMPLATEPAGEMATCH");
            map.Add(0x1217, "TWEI_FORMHORZDOCOFFSET");
            map.Add(0x1218, "TWEI_FORMVERTDOCOFFSET");
            map.Add(0x1219, "TWEI_BARCODECOUNT");
            map.Add(0x121A, "TWEI_BARCODECONFIDENCE");
            map.Add(0x121B, "TWEI_BARCODEROTATION");
            map.Add(0x121C, "TWEI_BARCODETEXTLENGTH");
            map.Add(0x121D, "TWEI_DESHADECOUNT");
            map.Add(0x121E, "TWEI_DESHADEBLACKCOUNTOLD");
            map.Add(0x121F, "TWEI_DESHADEBLACKCOUNTNEW");
            map.Add(0x1220, "TWEI_DESHADEBLACKRLMIN");
            map.Add(0x1221, "TWEI_DESHADEBLACKRLMAX");
            map.Add(0x1222, "TWEI_DESHADEWHITECOUNTOLD");
            map.Add(0x1223, "TWEI_DESHADEWHITECOUNTNEW");
            map.Add(0x1224, "TWEI_DESHADEWHITERLMIN");
            map.Add(0x1225, "TWEI_DESHADEWHITERLAVE");
            map.Add(0x1226, "TWEI_DESHADEWHITERLMAX");
            map.Add(0x1227, "TWEI_BLACKSPECKLESREMOVED");
            map.Add(0x1228, "TWEI_WHITESPECKLESREMOVED");
            map.Add(0x1229, "TWEI_HORZLINECOUNT");
            map.Add(0x122A, "TWEI_VERTLINECOUNT");
            map.Add(0x122B, "TWEI_DESKEWSTATUS");
            map.Add(0x122C, "TWEI_SKEWORIGINALANGLE");
            map.Add(0x122D, "TWEI_SKEWFINALANGLE");
            map.Add(0x122E, "TWEI_SKEWCONFIDENCE");
            map.Add(0x122F, "TWEI_SKEWWINDOWX1");
            map.Add(0x1230, "TWEI_SKEWWINDOWY1");
            map.Add(0x1231, "TWEI_SKEWWINDOWX2");
            map.Add(0x1232, "TWEI_SKEWWINDOWY2");
            map.Add(0x1233, "TWEI_SKEWWINDOWX3");
            map.Add(0x1234, "TWEI_SKEWWINDOWY3");
            map.Add(0x1235, "TWEI_SKEWWINDOWX4");
            map.Add(0x1236, "TWEI_SKEWWINDOWY4");
            map.Add(0x1238, "TWEI_BOOKNAME");
            map.Add(0x1239, "TWEI_CHAPTERNUMBER");
            map.Add(0x123A, "TWEI_DOCUMENTNUMBER");
            map.Add(0x123B, "TWEI_PAGENUMBER");
            map.Add(0x123C, "TWEI_CAMERA");
            map.Add(0x123D, "TWEI_FRAMENUMBER");
            map.Add(0x123E, "TWEI_FRAME");
            map.Add(0x123F, "TWEI_PIXELFLAVOR");
            map.Add(0x1240, "TWEI_ICCPROFILE");
            map.Add(0x1241, "TWEI_LASTSEGMENT");
            map.Add(0x1242, "TWEI_SEGMENTNUMBER");
            map.Add(0x1243, "TWEI_MAGDATA");
            map.Add(0x1244, "TWEI_MAGTYPE");
            map.Add(0x1245, "TWEI_PAGESIDE");
            map.Add(0x1246, "TWEI_FILESYSTEMSOURCE");
            map.Add(0x1247, "TWEI_IMAGEMERGED");
            map.Add(0x1248, "TWEI_MAGDATALENGTH");
            map.Add(0x1249, "TWEI_PAPERCOUNT");
            map.Add(0x124A, "TWEI_PRINTERTEXT");

            map.Add(0x0000, "TWEJ_NONE");
            map.Add(0x0001, "TWEJ_MIDSEPARATOR");
            map.Add(0x0002, "TWEJ_PATCH1");
            map.Add(0x0003, "TWEJ_PATCH2");
            map.Add(0x0004, "TWEJ_PATCH3");
            map.Add(0x0005, "TWEJ_PATCH4");
            map.Add(0x0006, "TWEJ_PATCH6");
            map.Add(0x0007, "TWEJ_PATCHT");

            mapTweiCodeToName = map;
            return mapTweiCodeToName;
        }

        private static Dictionary<string, int> mapTweiNameToCode;

        private static Dictionary<string, int> getMapTweiNameToCode()
        {
            if (mapTweiNameToCode != null)
            {
                return mapTweiNameToCode;
            }

            Dictionary<string, int> map = new Dictionary<string, int>();
            map.Add("TWEI_BARCODEX", 0x1200);
            map.Add("TWEI_BARCODEY", 0x1201);
            map.Add("TWEI_BARCODETEXT", 0x1202);
            map.Add("TWEI_BARCODETYPE", 0x1203);
            map.Add("TWEI_DESHADETOP", 0x1204);
            map.Add("TWEI_DESHADELEFT", 0x1205);
            map.Add("TWEI_DESHADEHEIGHT", 0x1206);
            map.Add("TWEI_DESHADEWIDTH", 0x1207);
            map.Add("TWEI_DESHADESIZE", 0x1208);
            map.Add("TWEI_SPECKLESREMOVED", 0x1209);
            map.Add("TWEI_HORZLINEXCOORD", 0x120A);
            map.Add("TWEI_HORZLINEYCOORD", 0x120B);
            map.Add("TWEI_HORZLINELENGTH", 0x120C);
            map.Add("TWEI_HORZLINETHICKNESS", 0x120D);
            map.Add("TWEI_VERTLINEXCOORD", 0x120E);
            map.Add("TWEI_VERTLINEYCOORD", 0x120F);
            map.Add("TWEI_VERTLINELENGTH", 0x1210);
            map.Add("TWEI_VERTLINETHICKNESS", 0x1211);
            map.Add("TWEI_PATCHCODE", 0x1212);
            map.Add("TWEI_ENDORSEDTEXT", 0x1213);
            map.Add("TWEI_FORMCONFIDENCE", 0x1214);
            map.Add("TWEI_FORMTEMPLATEMATCH", 0x1215);
            map.Add("TWEI_FORMTEMPLATEPAGEMATCH", 0x1216);
            map.Add("TWEI_FORMHORZDOCOFFSET", 0x1217);
            map.Add("TWEI_FORMVERTDOCOFFSET", 0x1218);
            map.Add("TWEI_BARCODECOUNT", 0x1219);
            map.Add("TWEI_BARCODECONFIDENCE", 0x121A);
            map.Add("TWEI_BARCODEROTATION", 0x121B);
            map.Add("TWEI_BARCODETEXTLENGTH", 0x121C);
            map.Add("TWEI_DESHADECOUNT", 0x121D);
            map.Add("TWEI_DESHADEBLACKCOUNTOLD", 0x121E);
            map.Add("TWEI_DESHADEBLACKCOUNTNEW", 0x121F);
            map.Add("TWEI_DESHADEBLACKRLMIN", 0x1220);
            map.Add("TWEI_DESHADEBLACKRLMAX", 0x1221);
            map.Add("TWEI_DESHADEWHITECOUNTOLD", 0x1222);
            map.Add("TWEI_DESHADEWHITECOUNTNEW", 0x1223);
            map.Add("TWEI_DESHADEWHITERLMIN", 0x1224);
            map.Add("TWEI_DESHADEWHITERLAVE", 0x1225);
            map.Add("TWEI_DESHADEWHITERLMAX", 0x1226);
            map.Add("TWEI_BLACKSPECKLESREMOVED", 0x1227);
            map.Add("TWEI_WHITESPECKLESREMOVED", 0x1228);
            map.Add("TWEI_HORZLINECOUNT", 0x1229);
            map.Add("TWEI_VERTLINECOUNT", 0x122A);
            map.Add("TWEI_DESKEWSTATUS", 0x122B);
            map.Add("TWEI_SKEWORIGINALANGLE", 0x122C);
            map.Add("TWEI_SKEWFINALANGLE", 0x122D);
            map.Add("TWEI_SKEWCONFIDENCE", 0x122E);
            map.Add("TWEI_SKEWWINDOWX1", 0x122F);
            map.Add("TWEI_SKEWWINDOWY1", 0x1230);
            map.Add("TWEI_SKEWWINDOWX2", 0x1231);
            map.Add("TWEI_SKEWWINDOWY2", 0x1232);
            map.Add("TWEI_SKEWWINDOWX3", 0x1233);
            map.Add("TWEI_SKEWWINDOWY3", 0x1234);
            map.Add("TWEI_SKEWWINDOWX4", 0x1235);
            map.Add("TWEI_SKEWWINDOWY4", 0x1236);
            map.Add("TWEI_BOOKNAME", 0x1238);
            map.Add("TWEI_CHAPTERNUMBER", 0x1239);
            map.Add("TWEI_DOCUMENTNUMBER", 0x123A);
            map.Add("TWEI_PAGENUMBER", 0x123B);
            map.Add("TWEI_CAMERA", 0x123C);
            map.Add("TWEI_FRAMENUMBER", 0x123D);
            map.Add("TWEI_FRAME", 0x123E);
            map.Add("TWEI_PIXELFLAVOR", 0x123F);
            map.Add("TWEI_ICCPROFILE", 0x1240);
            map.Add("TWEI_LASTSEGMENT", 0x1241);
            map.Add("TWEI_SEGMENTNUMBER", 0x1242);
            map.Add("TWEI_MAGDATA", 0x1243);
            map.Add("TWEI_MAGTYPE", 0x1244);
            map.Add("TWEI_PAGESIDE", 0x1245);
            map.Add("TWEI_FILESYSTEMSOURCE", 0x1246);
            map.Add("TWEI_IMAGEMERGED", 0x1247);
            map.Add("TWEI_MAGDATALENGTH", 0x1248);
            map.Add("TWEI_PAPERCOUNT", 0x1249);
            map.Add("TWEI_PRINTERTEXT", 0x124A);

            map.Add("TWEJ_NONE", 0x0000);
            map.Add("TWEJ_MIDSEPARATOR", 0x0001);
            map.Add("TWEJ_PATCH1", 0x0002);
            map.Add("TWEJ_PATCH2", 0x0003);
            map.Add("TWEJ_PATCH3", 0x0004);
            map.Add("TWEJ_PATCH4", 0x0005);
            map.Add("TWEJ_PATCH6", 0x0006);
            map.Add("TWEJ_PATCHT", 0x0007);
            mapTweiNameToCode = map;
            return mapTweiNameToCode;
        }

        private static Dictionary<string, int> mapTwrcNameToCode;

        private static Dictionary<string, int> getMapTwrcNameToCode()
        {
            if (mapTwrcNameToCode != null)
            {
                return mapTwrcNameToCode;
            }

            Dictionary<string, int> map = new Dictionary<string, int>();
            map.Add("TWRC_CUSTOMBASE", 0x8000);

            map.Add("TWRC_SUCCESS", 0);
            map.Add("TWRC_FAILURE", 1);
            map.Add("TWRC_CHECKSTATUS", 2);
            map.Add("TWRC_CANCEL", 3);
            map.Add("TWRC_DSEVENT", 4);
            map.Add("TWRC_NOTDSEVENT", 5);
            map.Add("TWRC_XFERDONE", 6);
            map.Add("TWRC_ENDOFLIST", 7);
            map.Add("TWRC_INFONOTSUPPORTED", 8);
            map.Add("TWRC_DATANOTAVAILABLE", 9);
            map.Add("TWRC_BUSY", 10);
            map.Add("TWRC_SCANNERLOCKED", 11);
            mapTwrcNameToCode = map;
            return mapTwrcNameToCode;
        }

        private static Dictionary<int, string> mapTwrcCodeToName;

        private static Dictionary<int, string> getMapTwrcCodeToName()
        {
            if (mapTwrcCodeToName != null)
            {
                return mapTwrcCodeToName;
            }

            Dictionary<int, string> map = new Dictionary<int, string>();
            map.Add(0x8000, "TWRC_CUSTOMBASE");

            map.Add(0, "TWRC_SUCCESS");
            map.Add(1, "TWRC_FAILURE");
            map.Add(2, "TWRC_CHECKSTATUS");
            map.Add(3, "TWRC_CANCEL");
            map.Add(4, "TWRC_DSEVENT");
            map.Add(5, "TWRC_NOTDSEVENT");
            map.Add(6, "TWRC_XFERDONE");
            map.Add(7, "TWRC_ENDOFLIST");
            map.Add(8, "TWRC_INFONOTSUPPORTED");
            map.Add(9, "TWRC_DATANOTAVAILABLE");
            map.Add(10, "TWRC_BUSY");
            map.Add(11, "TWRC_SCANNERLOCKED");
            mapTwrcCodeToName = map;
            return mapTwrcCodeToName;
        }


        private static Dictionary<string, int> mapTwccNameToCode;

        private static Dictionary<string, int> getMapTwccNameToCode()
        {
            if (mapTwccNameToCode != null)
            {
                return mapTwccNameToCode;
            }

            Dictionary<string, int> map = new Dictionary<string, int>();
            map.Add("TWCC_CUSTOMBASE", 0x8000);

            map.Add("TWCC_SUCCESS", 0);
            map.Add("TWCC_BUMMER", 1);
            map.Add("TWCC_LOWMEMORY", 2);
            map.Add("TWCC_NODS", 3);
            map.Add("TWCC_MAXCONNECTIONS", 4);
            map.Add("TWCC_OPERATIONERROR", 5);
            map.Add("TWCC_BADCAP", 6);
            map.Add("TWCC_BADPROTOCOL", 9);
            map.Add("TWCC_BADVALUE", 10);
            map.Add("TWCC_SEQERROR", 11);
            map.Add("TWCC_BADDEST", 12);
            map.Add("TWCC_CAPUNSUPPORTED", 13);
            map.Add("TWCC_CAPBADOPERATION", 14);
            map.Add("TWCC_CAPSEQERROR", 15);
            map.Add("TWCC_DENIED", 16);
            map.Add("TWCC_FILEEXISTS", 17);
            map.Add("TWCC_FILENOTFOUND", 18);
            map.Add("TWCC_NOTEMPTY", 19);
            map.Add("TWCC_PAPERJAM", 20);
            map.Add("TWCC_PAPERDOUBLEFEED", 21);
            map.Add("TWCC_FILEWRITEERROR", 22);
            map.Add("TWCC_CHECKDEVICEONLINE", 23);
            map.Add("TWCC_INTERLOCK", 24);
            map.Add("TWCC_DAMAGEDCORNER", 25);
            map.Add("TWCC_FOCUSERROR", 26);
            map.Add("TWCC_DOCTOOLIGHT", 27);
            map.Add("TWCC_DOCTOODARK", 28);
            map.Add("TWCC_NOMEDIA", 29);
            mapTwccNameToCode = map;
            return mapTwccNameToCode;
        }

        private static Dictionary<int, string> mapTwccCodeToName;

        private static Dictionary<int, string> getMapTwccCodeToName()
        {
            if (mapTwccCodeToName != null)
            {
                return mapTwccCodeToName;
            }

            Dictionary<int, string> map = new Dictionary<int, string>();
            map.Add(0x8000, "TWCC_CUSTOMBASE");

            map.Add(0, "TWCC_SUCCESS");
            map.Add(1, "TWCC_BUMMER");
            map.Add(2, "TWCC_LOWMEMORY");
            map.Add(3, "TWCC_NODS");
            map.Add(4, "TWCC_MAXCONNECTIONS");
            map.Add(5, "TWCC_OPERATIONERROR");
            map.Add(6, "TWCC_BADCAP");
            map.Add(9, "TWCC_BADPROTOCOL");
            map.Add(10, "TWCC_BADVALUE");
            map.Add(11, "TWCC_SEQERROR");
            map.Add(12, "TWCC_BADDEST");
            map.Add(13, "TWCC_CAPUNSUPPORTED");
            map.Add(14, "TWCC_CAPBADOPERATION");
            map.Add(15, "TWCC_CAPSEQERROR");
            map.Add(16, "TWCC_DENIED");
            map.Add(17, "TWCC_FILEEXISTS");
            map.Add(18, "TWCC_FILENOTFOUND");
            map.Add(19, "TWCC_NOTEMPTY");
            map.Add(20, "TWCC_PAPERJAM");
            map.Add(21, "TWCC_PAPERDOUBLEFEED");
            map.Add(22, "TWCC_FILEWRITEERROR");
            map.Add(23, "TWCC_CHECKDEVICEONLINE");
            map.Add(24, "TWCC_INTERLOCK");
            map.Add(25, "TWCC_DAMAGEDCORNER");
            map.Add(26, "TWCC_FOCUSERROR");
            map.Add(27, "TWCC_DOCTOOLIGHT");
            map.Add(28, "TWCC_DOCTOODARK");
            map.Add(29, "TWCC_NOMEDIA");
            mapTwccCodeToName = map;
            return mapTwccCodeToName;
        }

        private static Dictionary<string, int> mapConstantNameToIntValue;

        private static Dictionary<string, int> getMapConstantNameToIntValue()
        {
            if (mapConstantNameToIntValue != null)
            {
                return mapConstantNameToIntValue;
            }

            Dictionary<string, int> map = new Dictionary<string, int>();
            map.Add("CAP_CUSTOMBASE", 0x8000); /* Base of custom capabilities */

            /* all data sources are REQUIRED to support these caps */
            map.Add("CAP_XFERCOUNT", 0x0001);

            /* image data sources are REQUIRED to support these caps */
            map.Add("ICAP_COMPRESSION", 0x0100);
            map.Add("ICAP_PIXELTYPE", 0x0101);
            map.Add("ICAP_UNITS", 0x0102);
            map.Add("ICAP_XFERMECH", 0x0103);

            /* all data sources MAY support these caps */
            map.Add("CAP_AUTHOR", 0x1000);
            map.Add("CAP_CAPTION", 0x1001);
            map.Add("CAP_FEEDERENABLED", 0x1002);
            map.Add("CAP_FEEDERLOADED", 0x1003);
            map.Add("CAP_TIMEDATE", 0x1004);
            map.Add("CAP_SUPPORTEDCAPS", 0x1005);
            map.Add("CAP_EXTENDEDCAPS", 0x1006);
            map.Add("CAP_AUTOFEED", 0x1007);
            map.Add("CAP_CLEARPAGE", 0x1008);
            map.Add("CAP_FEEDPAGE", 0x1009);
            map.Add("CAP_REWINDPAGE", 0x100a);
            map.Add("CAP_INDICATORS", 0x100b);
            map.Add("CAP_PAPERDETECTABLE", 0x100d);
            map.Add("CAP_UICONTROLLABLE", 0x100e);
            map.Add("CAP_DEVICEONLINE", 0x100f);
            map.Add("CAP_AUTOSCAN", 0x1010);
            map.Add("CAP_THUMBNAILSENABLED", 0x1011);
            map.Add("CAP_DUPLEX", 0x1012);
            map.Add("CAP_DUPLEXENABLED", 0x1013);
            map.Add("CAP_ENABLEDSUIONLY", 0x1014);
            map.Add("CAP_CUSTOMDSDATA", 0x1015);
            map.Add("CAP_ENDORSER", 0x1016);
            map.Add("CAP_JOBCONTROL", 0x1017);
            map.Add("CAP_ALARMS", 0x1018);
            map.Add("CAP_ALARMVOLUME", 0x1019);
            map.Add("CAP_AUTOMATICCAPTURE", 0x101a);
            map.Add("CAP_TIMEBEFOREFIRSTCAPTURE", 0x101b);
            map.Add("CAP_TIMEBETWEENCAPTURES", 0x101c);
            map.Add("CAP_CLEARBUFFERS", 0x101d);
            map.Add("CAP_MAXBATCHBUFFERS", 0x101e);
            map.Add("CAP_DEVICETIMEDATE", 0x101f);
            map.Add("CAP_POWERSUPPLY", 0x1020);
            map.Add("CAP_CAMERAPREVIEWUI", 0x1021);
            map.Add("CAP_DEVICEEVENT", 0x1022);
            map.Add("CAP_SERIALNUMBER", 0x1024);
            map.Add("CAP_PRINTER", 0x1026);
            map.Add("CAP_PRINTERENABLED", 0x1027);
            map.Add("CAP_PRINTERINDEX", 0x1028);
            map.Add("CAP_PRINTERMODE", 0x1029);
            map.Add("CAP_PRINTERSTRING", 0x102a);
            map.Add("CAP_PRINTERSUFFIX", 0x102b);
            map.Add("CAP_LANGUAGE", 0x102c);
            map.Add("CAP_FEEDERALIGNMENT", 0x102d);
            map.Add("CAP_FEEDERORDER", 0x102e);
            map.Add("CAP_REACQUIREALLOWED", 0x1030);
            map.Add("CAP_BATTERYMINUTES", 0x1032);
            map.Add("CAP_BATTERYPERCENTAGE", 0x1033);
            map.Add("CAP_CAMERASIDE", 0x1034);
            map.Add("CAP_SEGMENTED", 0x1035);
            map.Add("CAP_CAMERAENABLED", 0x1036);
            map.Add("CAP_CAMERAORDER", 0x1037);
            map.Add("CAP_MICRENABLED", 0x1038);
            map.Add("CAP_FEEDERPREP", 0x1039);
            map.Add("CAP_FEEDERPOCKET", 0x103a);
            map.Add("CAP_AUTOMATICSENSEMEDIUM", 0x103b);
            map.Add("CAP_CUSTOMINTERFACEGUID", 0x103c);
            map.Add("CAP_SUPPORTEDCAPSSEGMENTUNIQUE", 0x103d);
            map.Add("CAP_SUPPORTEDDATS", 0x103e);
            map.Add("CAP_DOUBLEFEEDDETECTION", 0x103f);
            map.Add("CAP_DOUBLEFEEDDETECTIONLENGTH", 0x1040);
            map.Add("CAP_DOUBLEFEEDDETECTIONSENSITIVITY", 0x1041);
            map.Add("CAP_DOUBLEFEEDDETECTIONRESPONSE", 0x1042);
            map.Add("CAP_PAPERHANDLING", 0x1043);
            map.Add("CAP_INDICATORSMODE", 0x1044);
            map.Add("CAP_PRINTERVERTICALOFFSET", 0x1045);
            map.Add("CAP_POWERSAVETIME", 0x1046);
            map.Add("CAP_PRINTERCHARROTATION", 0x1047);
            map.Add("CAP_PRINTERFONTSTYLE", 0x1048);
            map.Add("CAP_PRINTERINDEXLEADCHAR", 0x1049);
            map.Add("CAP_PRINTERINDEXMAXVALUE", 0x104A);
            map.Add("CAP_PRINTERINDEXNUMDIGITS", 0x104B);
            map.Add("CAP_PRINTERINDEXSTEP", 0x104C);
            map.Add("CAP_PRINTERINDEXTRIGGER", 0x104D);
            map.Add("CAP_PRINTERSTRINGPREVIEW", 0x104E);

            /* image data sources MAY support these caps */
            map.Add("ICAP_AUTOBRIGHT", 0x1100);
            map.Add("ICAP_BRIGHTNESS", 0x1101);
            map.Add("ICAP_CONTRAST", 0x1103);
            map.Add("ICAP_CUSTHALFTONE", 0x1104);
            map.Add("ICAP_EXPOSURETIME", 0x1105);
            map.Add("ICAP_FILTER", 0x1106);
            map.Add("ICAP_FLASHUSED", 0x1107);
            map.Add("ICAP_GAMMA", 0x1108);
            map.Add("ICAP_HALFTONES", 0x1109);
            map.Add("ICAP_HIGHLIGHT", 0x110a);
            map.Add("ICAP_IMAGEFILEFORMAT", 0x110c);
            map.Add("ICAP_LAMPSTATE", 0x110d);
            map.Add("ICAP_LIGHTSOURCE", 0x110e);
            map.Add("ICAP_ORIENTATION", 0x1110);
            map.Add("ICAP_PHYSICALWIDTH", 0x1111);
            map.Add("ICAP_PHYSICALHEIGHT", 0x1112);
            map.Add("ICAP_SHADOW", 0x1113);
            map.Add("ICAP_FRAMES", 0x1114);
            map.Add("ICAP_XNATIVERESOLUTION", 0x1116);
            map.Add("ICAP_YNATIVERESOLUTION", 0x1117);
            map.Add("ICAP_XRESOLUTION", 0x1118);
            map.Add("ICAP_YRESOLUTION", 0x1119);
            map.Add("ICAP_MAXFRAMES", 0x111a);
            map.Add("ICAP_TILES", 0x111b);
            map.Add("ICAP_BITORDER", 0x111c);
            map.Add("ICAP_CCITTKFACTOR", 0x111d);
            map.Add("ICAP_LIGHTPATH", 0x111e);
            map.Add("ICAP_PIXELFLAVOR", 0x111f);
            map.Add("ICAP_PLANARCHUNKY", 0x1120);
            map.Add("ICAP_ROTATION", 0x1121);
            map.Add("ICAP_SUPPORTEDSIZES", 0x1122);
            map.Add("ICAP_THRESHOLD", 0x1123);
            map.Add("ICAP_XSCALING", 0x1124);
            map.Add("ICAP_YSCALING", 0x1125);
            map.Add("ICAP_BITORDERCODES", 0x1126);
            map.Add("ICAP_PIXELFLAVORCODES", 0x1127);
            map.Add("ICAP_JPEGPIXELTYPE", 0x1128);
            map.Add("ICAP_TIMEFILL", 0x112a);
            map.Add("ICAP_BITDEPTH", 0x112b);
            map.Add("ICAP_BITDEPTHREDUCTION", 0x112c);
            map.Add("ICAP_UNDEFINEDIMAGESIZE", 0x112d);
            map.Add("ICAP_IMAGEDATASET", 0x112e);
            map.Add("ICAP_EXTIMAGEINFO", 0x112f);
            map.Add("ICAP_MINIMUMHEIGHT", 0x1130);
            map.Add("ICAP_MINIMUMWIDTH", 0x1131);
            map.Add("ICAP_AUTODISCARDBLANKPAGES", 0x1134);
            map.Add("ICAP_FLIPROTATION", 0x1136);
            map.Add("ICAP_BARCODEDETECTIONENABLED", 0x1137);
            map.Add("ICAP_SUPPORTEDBARCODETYPES", 0x1138);
            map.Add("ICAP_BARCODEMAXSEARCHPRIORITIES", 0x1139);
            map.Add("ICAP_BARCODESEARCHPRIORITIES", 0x113a);
            map.Add("ICAP_BARCODESEARCHMODE", 0x113b);
            map.Add("ICAP_BARCODEMAXRETRIES", 0x113c);
            map.Add("ICAP_BARCODETIMEOUT", 0x113d);
            map.Add("ICAP_ZOOMFACTOR", 0x113e);
            map.Add("ICAP_PATCHCODEDETECTIONENABLED", 0x113f);
            map.Add("ICAP_SUPPORTEDPATCHCODETYPES", 0x1140);
            map.Add("ICAP_PATCHCODEMAXSEARCHPRIORITIES", 0x1141);
            map.Add("ICAP_PATCHCODESEARCHPRIORITIES", 0x1142);
            map.Add("ICAP_PATCHCODESEARCHMODE", 0x1143);
            map.Add("ICAP_PATCHCODEMAXRETRIES", 0x1144);
            map.Add("ICAP_PATCHCODETIMEOUT", 0x1145);
            map.Add("ICAP_FLASHUSED2", 0x1146);
            map.Add("ICAP_IMAGEFILTER", 0x1147);
            map.Add("ICAP_NOISEFILTER", 0x1148);
            map.Add("ICAP_OVERSCAN", 0x1149);
            map.Add("ICAP_AUTOMATICBORDERDETECTION", 0x1150);
            map.Add("ICAP_AUTOMATICDESKEW", 0x1151);
            map.Add("ICAP_AUTOMATICROTATE", 0x1152);
            map.Add("ICAP_JPEGQUALITY", 0x1153);
            map.Add("ICAP_FEEDERTYPE", 0x1154);
            map.Add("ICAP_ICCPROFILE", 0x1155);
            map.Add("ICAP_AUTOSIZE", 0x1156);
            map.Add("ICAP_AUTOMATICCROPUSESFRAME", 0x1157);
            map.Add("ICAP_AUTOMATICLENGTHDETECTION", 0x1158);
            map.Add("ICAP_AUTOMATICCOLORENABLED", 0x1159);
            map.Add("ICAP_AUTOMATICCOLORNONCOLORPIXELTYPE", 0x115a);
            map.Add("ICAP_COLORMANAGEMENTENABLED", 0x115b);
            map.Add("ICAP_IMAGEMERGE", 0x115c);
            map.Add("ICAP_IMAGEMERGEHEIGHTTHRESHOLD", 0x115d);
            map.Add("ICAP_SUPPORTEDEXTIMAGEINFO", 0x115e);
            map.Add("ICAP_FILMTYPE", 0x115f);
            map.Add("ICAP_MIRROR", 0x1160);
            map.Add("ICAP_JPEGSUBSAMPLING", 0x1161);

            map.Add("CAP_SUPPORTEDCAPSEXT", 0x100c);
            map.Add("CAP_PAGEMULTIPLEACQUIRE", 0x1023);
            map.Add("CAP_PAPERBINDING", 0x102f);
            map.Add("CAP_PASSTHRU", 0x1031);
            map.Add("CAP_POWERDOWNTIME", 0x1034);

            // TWEI
            map.Add("TWEI_BARCODEX", 0x1200);
            map.Add("TWEI_BARCODEY", 0x1201);
            map.Add("TWEI_BARCODETEXT", 0x1202);
            map.Add("TWEI_BARCODETYPE", 0x1203);
            map.Add("TWEI_DESHADETOP", 0x1204);
            map.Add("TWEI_DESHADELEFT", 0x1205);
            map.Add("TWEI_DESHADEHEIGHT", 0x1206);
            map.Add("TWEI_DESHADEWIDTH", 0x1207);
            map.Add("TWEI_DESHADESIZE", 0x1208);
            map.Add("TWEI_SPECKLESREMOVED", 0x1209);
            map.Add("TWEI_HORZLINEXCOORD", 0x120A);
            map.Add("TWEI_HORZLINEYCOORD", 0x120B);
            map.Add("TWEI_HORZLINELENGTH", 0x120C);
            map.Add("TWEI_HORZLINETHICKNESS", 0x120D);
            map.Add("TWEI_VERTLINEXCOORD", 0x120E);
            map.Add("TWEI_VERTLINEYCOORD", 0x120F);
            map.Add("TWEI_VERTLINELENGTH", 0x1210);
            map.Add("TWEI_VERTLINETHICKNESS", 0x1211);
            map.Add("TWEI_PATCHCODE", 0x1212);
            map.Add("TWEI_ENDORSEDTEXT", 0x1213);
            map.Add("TWEI_FORMCONFIDENCE", 0x1214);
            map.Add("TWEI_FORMTEMPLATEMATCH", 0x1215);
            map.Add("TWEI_FORMTEMPLATEPAGEMATCH", 0x1216);
            map.Add("TWEI_FORMHORZDOCOFFSET", 0x1217);
            map.Add("TWEI_FORMVERTDOCOFFSET", 0x1218);
            map.Add("TWEI_BARCODECOUNT", 0x1219);
            map.Add("TWEI_BARCODECONFIDENCE", 0x121A);
            map.Add("TWEI_BARCODEROTATION", 0x121B);
            map.Add("TWEI_BARCODETEXTLENGTH", 0x121C);
            map.Add("TWEI_DESHADECOUNT", 0x121D);
            map.Add("TWEI_DESHADEBLACKCOUNTOLD", 0x121E);
            map.Add("TWEI_DESHADEBLACKCOUNTNEW", 0x121F);
            map.Add("TWEI_DESHADEBLACKRLMIN", 0x1220);
            map.Add("TWEI_DESHADEBLACKRLMAX", 0x1221);
            map.Add("TWEI_DESHADEWHITECOUNTOLD", 0x1222);
            map.Add("TWEI_DESHADEWHITECOUNTNEW", 0x1223);
            map.Add("TWEI_DESHADEWHITERLMIN", 0x1224);
            map.Add("TWEI_DESHADEWHITERLAVE", 0x1225);
            map.Add("TWEI_DESHADEWHITERLMAX", 0x1226);
            map.Add("TWEI_BLACKSPECKLESREMOVED", 0x1227);
            map.Add("TWEI_WHITESPECKLESREMOVED", 0x1228);
            map.Add("TWEI_HORZLINECOUNT", 0x1229);
            map.Add("TWEI_VERTLINECOUNT", 0x122A);
            map.Add("TWEI_DESKEWSTATUS", 0x122B);
            map.Add("TWEI_SKEWORIGINALANGLE", 0x122C);
            map.Add("TWEI_SKEWFINALANGLE", 0x122D);
            map.Add("TWEI_SKEWCONFIDENCE", 0x122E);
            map.Add("TWEI_SKEWWINDOWX1", 0x122F);
            map.Add("TWEI_SKEWWINDOWY1", 0x1230);
            map.Add("TWEI_SKEWWINDOWX2", 0x1231);
            map.Add("TWEI_SKEWWINDOWY2", 0x1232);
            map.Add("TWEI_SKEWWINDOWX3", 0x1233);
            map.Add("TWEI_SKEWWINDOWY3", 0x1234);
            map.Add("TWEI_SKEWWINDOWX4", 0x1235);
            map.Add("TWEI_SKEWWINDOWY4", 0x1236);
            map.Add("TWEI_BOOKNAME", 0x1238);
            map.Add("TWEI_CHAPTERNUMBER", 0x1239);
            map.Add("TWEI_DOCUMENTNUMBER", 0x123A);
            map.Add("TWEI_PAGENUMBER", 0x123B);
            map.Add("TWEI_CAMERA", 0x123C);
            map.Add("TWEI_FRAMENUMBER", 0x123D);
            map.Add("TWEI_FRAME", 0x123E);
            map.Add("TWEI_PIXELFLAVOR", 0x123F);
            map.Add("TWEI_ICCPROFILE", 0x1240);
            map.Add("TWEI_LASTSEGMENT", 0x1241);
            map.Add("TWEI_SEGMENTNUMBER", 0x1242);
            map.Add("TWEI_MAGDATA", 0x1243);
            map.Add("TWEI_MAGTYPE", 0x1244);
            map.Add("TWEI_PAGESIDE", 0x1245);
            map.Add("TWEI_FILESYSTEMSOURCE", 0x1246);
            map.Add("TWEI_IMAGEMERGED", 0x1247);
            map.Add("TWEI_MAGDATALENGTH", 0x1248);
            map.Add("TWEI_PAPERCOUNT", 0x1249);
            map.Add("TWEI_PRINTERTEXT", 0x124A);

            map.Add("TWEJ_NONE", 0x0000);
            map.Add("TWEJ_MIDSEPARATOR", 0x0001);
            map.Add("TWEJ_PATCH1", 0x0002);
            map.Add("TWEJ_PATCH2", 0x0003);
            map.Add("TWEJ_PATCH3", 0x0004);
            map.Add("TWEJ_PATCH4", 0x0005);
            map.Add("TWEJ_PATCH6", 0x0006);
            map.Add("TWEJ_PATCHT", 0x0007);


            /***************************************************************************
             *            Return Codes and Condition Codes section                     *
             ***************************************************************************/

            map.Add("TWRC_CUSTOMBASE", 0x8000);

            map.Add("TWRC_SUCCESS", 0);
            map.Add("TWRC_FAILURE", 1);
            map.Add("TWRC_CHECKSTATUS", 2);
            map.Add("TWRC_CANCEL", 3);
            map.Add("TWRC_DSEVENT", 4);
            map.Add("TWRC_NOTDSEVENT", 5);
            map.Add("TWRC_XFERDONE", 6);
            map.Add("TWRC_ENDOFLIST", 7);
            map.Add("TWRC_INFONOTSUPPORTED", 8);
            map.Add("TWRC_DATANOTAVAILABLE", 9);
            map.Add("TWRC_BUSY", 10);
            map.Add("TWRC_SCANNERLOCKED", 11);

            /* Condition Codes: Application gets these by doing DG_CONTROL DAT_STATUS MSG_GET.  */
            map.Add("TWCC_CUSTOMBASE", 0x8000);

            map.Add("TWCC_SUCCESS", 0);
            map.Add("TWCC_BUMMER", 1);
            map.Add("TWCC_LOWMEMORY", 2);
            map.Add("TWCC_NODS", 3);
            map.Add("TWCC_MAXCONNECTIONS", 4);
            map.Add("TWCC_OPERATIONERROR", 5);
            map.Add("TWCC_BADCAP", 6);
            map.Add("TWCC_BADPROTOCOL", 9);
            map.Add("TWCC_BADVALUE", 10);
            map.Add("TWCC_SEQERROR", 11);
            map.Add("TWCC_BADDEST", 12);
            map.Add("TWCC_CAPUNSUPPORTED", 13);
            map.Add("TWCC_CAPBADOPERATION", 14);
            map.Add("TWCC_CAPSEQERROR", 15);
            map.Add("TWCC_DENIED", 16);
            map.Add("TWCC_FILEEXISTS", 17);
            map.Add("TWCC_FILENOTFOUND", 18);
            map.Add("TWCC_NOTEMPTY", 19);
            map.Add("TWCC_PAPERJAM", 20);
            map.Add("TWCC_PAPERDOUBLEFEED", 21);
            map.Add("TWCC_FILEWRITEERROR", 22);
            map.Add("TWCC_CHECKDEVICEONLINE", 23);
            map.Add("TWCC_INTERLOCK", 24);
            map.Add("TWCC_DAMAGEDCORNER", 25);
            map.Add("TWCC_FOCUSERROR", 26);
            map.Add("TWCC_DOCTOOLIGHT", 27);
            map.Add("TWCC_DOCTOODARK", 28);
            map.Add("TWCC_NOMEDIA", 29);

            /* CAP_CLEARBUFFERS values */
            map.Add("TWCB_AUTO", 0);
            map.Add("TWCB_CLEAR", 1);
            map.Add("TWCB_NOCLEAR", 2);

            /* TW_PASSTHRU.Direction values. */
            map.Add("TWDR_GET", 1);
            map.Add("TWDR_SET", 2);

            /* TWEI_DESKEWSTATUS values. */
            map.Add("TWDSK_SUCCESS", 0);
            map.Add("TWDSK_REPORTONLY", 1);
            map.Add("TWDSK_FAIL", 2);
            map.Add("TWDSK_DISABLED", 3);

            /* CAP_DUPLEX values */
            map.Add("TWDX_NONE", 0);
            map.Add("TWDX_1PASSDUPLEX", 1);
            map.Add("TWDX_2PASSDUPLEX", 2);

            /* CAP_FEEDERALIGNMENT values */
            map.Add("TWFA_NONE", 0);
            map.Add("TWFA_LEFT", 1);
            map.Add("TWFA_CENTER", 2);
            map.Add("TWFA_RIGHT", 3);

            /* ICAP_FEEDERTYPE values*/
            map.Add("TWFE_GENERAL", 0);
            map.Add("TWFE_PHOTO", 1);

            /* ICAP_IMAGEFILEFORMAT values */
            map.Add("TWFF_TIFF", 0);
            map.Add("TWFF_PICT", 1);
            map.Add("TWFF_BMP", 2);
            map.Add("TWFF_XBM", 3);
            map.Add("TWFF_JFIF", 4);
            map.Add("TWFF_FPX", 5);
            map.Add("TWFF_TIFFMULTI", 6);
            map.Add("TWFF_PNG", 7);
            map.Add("TWFF_SPIFF", 8);
            map.Add("TWFF_EXIF", 9);
            map.Add("TWFF_PDF", 10);
            map.Add("TWFF_JP2", 11);
            map.Add("TWFF_JPX", 13);
            map.Add("TWFF_DEJAVU", 14);
            map.Add("TWFF_PDFA", 15);
            map.Add("TWFF_PDFA2", 16);

            /* ICAP_FLASHUSED2 values */
            map.Add("TWFL_NONE", 0);
            map.Add("TWFL_OFF", 1);
            map.Add("TWFL_ON", 2);
            map.Add("TWFL_AUTO", 3);
            map.Add("TWFL_REDEYE", 4);

            /* CAP_FEEDERORDER values */
            map.Add("TWFO_FIRSTPAGEFIRST", 0);
            map.Add("TWFO_LASTPAGEFIRST", 1);

            /* CAP_FEEDERPOCKET values*/
            map.Add("TWFP_POCKETERROR", 0);
            map.Add("TWFP_POCKET1", 1);
            map.Add("TWFP_POCKET2", 2);
            map.Add("TWFP_POCKET3", 3);
            map.Add("TWFP_POCKET4", 4);
            map.Add("TWFP_POCKET5", 5);
            map.Add("TWFP_POCKET6", 6);
            map.Add("TWFP_POCKET7", 7);
            map.Add("TWFP_POCKET8", 8);
            map.Add("TWFP_POCKET9", 9);
            map.Add("TWFP_POCKET10", 10);
            map.Add("TWFP_POCKET11", 11);
            map.Add("TWFP_POCKET12", 12);
            map.Add("TWFP_POCKET13", 13);
            map.Add("TWFP_POCKET14", 14);
            map.Add("TWFP_POCKET15", 15);
            map.Add("TWFP_POCKET16", 16);

            /* ICAP_FLIPROTATION values */
            map.Add("TWFR_BOOK", 0);
            map.Add("TWFR_FANFOLD", 1);

            /* ICAP_FILTER values */
            map.Add("TWFT_RED", 0);
            map.Add("TWFT_GREEN", 1);
            map.Add("TWFT_BLUE", 2);
            map.Add("TWFT_NONE", 3);
            map.Add("TWFT_WHITE", 4);
            map.Add("TWFT_CYAN", 5);
            map.Add("TWFT_MAGENTA", 6);
            map.Add("TWFT_YELLOW", 7);
            map.Add("TWFT_BLACK", 8);

            /* ICAP_LIGHTPATH values */
            map.Add("TWLP_REFLECTIVE", 0);
            map.Add("TWLP_TRANSMISSIVE", 1);

            /* ICAP_LIGHTSOURCE values */
            map.Add("TWLS_RED", 0);
            map.Add("TWLS_GREEN", 1);
            map.Add("TWLS_BLUE", 2);
            map.Add("TWLS_NONE", 3);
            map.Add("TWLS_WHITE", 4);
            map.Add("TWLS_UV", 5);
            map.Add("TWLS_IR", 6);

            /* ICAP_NOISEFILTER values */
            map.Add("TWNF_NONE", 0);
            map.Add("TWNF_AUTO", 1);
            map.Add("TWNF_LONEPIXEL", 2);
            map.Add("TWNF_MAJORITYRULE", 3);

            /* ICAP_ORIENTATION values */
            map.Add("TWOR_ROT0", 0);
            map.Add("TWOR_ROT90", 1);
            map.Add("TWOR_ROT180", 2);
            map.Add("TWOR_ROT270", 3);
            map.Add("TWOR_PORTRAIT", TWOR_ROT0);
            map.Add("TWOR_LANDSCAPE", TWOR_ROT270);
            map.Add("TWOR_AUTO", 4);
            map.Add("TWOR_AUTOTEXT", 5);
            map.Add("TWOR_AUTOPICTURE", 6);

            /* ICAP_OVERSCAN values */
            map.Add("TWOV_NONE", 0);
            map.Add("TWOV_AUTO", 1);
            map.Add("TWOV_TOPBOTTOM", 2);
            map.Add("TWOV_LEFTRIGHT", 3);
            map.Add("TWOV_ALL", 4);

            /* Palette types for TW_PALETTE8 */
            map.Add("TWPA_RGB", 0);
            map.Add("TWPA_GRAY", 1);
            map.Add("TWPA_CMY", 2);

            /* ICAP_PLANARCHUNKY values */
            map.Add("TWPC_CHUNKY", 0);
            map.Add("TWPC_PLANAR", 1);

            /* TWEI_PATCHCODE values*/
            map.Add("TWPCH_PATCH1", 0);
            map.Add("TWPCH_PATCH2", 1);
            map.Add("TWPCH_PATCH3", 2);
            map.Add("TWPCH_PATCH4", 3);
            map.Add("TWPCH_PATCH6", 4);
            map.Add("TWPCH_PATCHT", 5);

            /* ICAP_PIXELFLAVOR values */
            map.Add("TWPF_CHOCOLATE", 0);
            map.Add("TWPF_VANILLA", 1);

            /* CAP_PRINTERMODE values */
            map.Add("TWPM_SINGLESTRING", 0);
            map.Add("TWPM_MULTISTRING", 1);
            map.Add("TWPM_COMPOUNDSTRING", 2);

            /* CAP_PRINTER values */
            map.Add("TWPR_IMPRINTERTOPBEFORE", 0);
            map.Add("TWPR_IMPRINTERTOPAFTER", 1);
            map.Add("TWPR_IMPRINTERBOTTOMBEFORE", 2);
            map.Add("TWPR_IMPRINTERBOTTOMAFTER", 3);
            map.Add("TWPR_ENDORSERTOPBEFORE", 4);
            map.Add("TWPR_ENDORSERTOPAFTER", 5);
            map.Add("TWPR_ENDORSERBOTTOMBEFORE", 6);
            map.Add("TWPR_ENDORSERBOTTOMAFTER", 7);

            /* CAP_PRINTERFONTSTYLE Added 2.3 */
            map.Add("TWPF_NORMAL", 0);
            map.Add("TWPF_BOLD", 1);
            map.Add("TWPF_ITALIC", 2);
            map.Add("TWPF_LARGESIZE", 3);
            map.Add("TWPF_SMALLSIZE", 4);

            /* CAP_PRINTERINDEXTRIGGER Added 2.3 */
            map.Add("TWCT_PAGE", 0);
            map.Add("TWCT_PATCH1", 1);
            map.Add("TWCT_PATCH2", 2);
            map.Add("TWCT_PATCH3", 3);
            map.Add("TWCT_PATCH4", 4);
            map.Add("TWCT_PATCHT", 5);
            map.Add("TWCT_PATCH6", 6);

            /* CAP_POWERSUPPLY values */
            map.Add("TWPS_EXTERNAL", 0);
            map.Add("TWPS_BATTERY", 1);

            /* ICAP_PIXELTYPE values (PT_ means Pixel Type) */
            map.Add("TWPT_BW", 0);
            map.Add("TWPT_GRAY", 1);
            map.Add("TWPT_RGB", 2);
            map.Add("TWPT_PALETTE", 3);
            map.Add("TWPT_CMY", 4);
            map.Add("TWPT_CMYK", 5);
            map.Add("TWPT_YUV", 6);
            map.Add("TWPT_YUVK", 7);
            map.Add("TWPT_CIEXYZ", 8);
            map.Add("TWPT_LAB", 9);
            map.Add("TWPT_SRGB", 10);
            map.Add("TWPT_SCRGB", 11);
            map.Add("TWPT_INFRARED", 16);

            /* CAP_SEGMENTED values */
            map.Add("TWSG_NONE", 0);
            map.Add("TWSG_AUTO", 1);
            map.Add("TWSG_MANUAL", 2);

            /* ICAP_FILMTYPE values */
            map.Add("TWFM_POSITIVE", 0);
            map.Add("TWFM_NEGATIVE", 1);

            /* CAP_DOUBLEFEEDDETECTION */
            map.Add("TWDF_ULTRASONIC", 0);
            map.Add("TWDF_BYLENGTH", 1);
            map.Add("TWDF_INFRARED", 2);

            /* CAP_DOUBLEFEEDDETECTIONSENSITIVITY */
            map.Add("TWUS_LOW", 0);
            map.Add("TWUS_MEDIUM", 1);
            map.Add("TWUS_HIGH", 2);

            /* CAP_DOUBLEFEEDDETECTIONRESPONSE */
            map.Add("TWDP_STOP", 0);
            map.Add("TWDP_STOPANDWAIT", 1);
            map.Add("TWDP_SOUND", 2);
            map.Add("TWDP_DONOTIMPRINT", 3);

            /* ICAP_MIRROR values */
            map.Add("TWMR_NONE", 0);
            map.Add("TWMR_VERTICAL", 1);
            map.Add("TWMR_HORIZONTAL", 2);

            /* CAP_PAPERHANDLING values */
            map.Add("TWPH_NORMAL", 0);
            map.Add("TWPH_FRAGILE", 1);
            map.Add("TWPH_THICK", 2);
            map.Add("TWPH_TRIFOLD", 3);
            map.Add("TWPH_PHOTOGRAPH", 4);

            /* CAP_INDICATORSMODE values */
            map.Add("TWCI_INFO", 0);
            map.Add("TWCI_WARNING", 1);
            map.Add("TWCI_ERROR", 2);
            map.Add("TWCI_WARMUP", 3);

            /* ICAP_SUPPORTEDSIZES values (SS_ means Supported Sizes) */
            map.Add("TWSS_NONE", 0);
            map.Add("TWSS_A4", 1);
            map.Add("TWSS_JISB5", 2);
            map.Add("TWSS_USLETTER", 3);
            map.Add("TWSS_USLEGAL", 4);
            map.Add("TWSS_A5", 5);
            map.Add("TWSS_ISOB4", 6);
            map.Add("TWSS_ISOB6", 7);
            map.Add("TWSS_USLEDGER", 9);
            map.Add("TWSS_USEXECUTIVE", 10);
            map.Add("TWSS_A3", 11);
            map.Add("TWSS_ISOB3", 12);
            map.Add("TWSS_A6", 13);
            map.Add("TWSS_C4", 14);
            map.Add("TWSS_C5", 15);
            map.Add("TWSS_C6", 16);
            map.Add("TWSS_4A0", 17);
            map.Add("TWSS_2A0", 18);
            map.Add("TWSS_A0", 19);
            map.Add("TWSS_A1", 20);
            map.Add("TWSS_A2", 21);
            map.Add("TWSS_A7", 22);
            map.Add("TWSS_A8", 23);
            map.Add("TWSS_A9", 24);
            map.Add("TWSS_A10", 25);
            map.Add("TWSS_ISOB0", 26);
            map.Add("TWSS_ISOB1", 27);
            map.Add("TWSS_ISOB2", 28);
            map.Add("TWSS_ISOB5", 29);
            map.Add("TWSS_ISOB7", 30);
            map.Add("TWSS_ISOB8", 31);
            map.Add("TWSS_ISOB9", 32);
            map.Add("TWSS_ISOB10", 33);
            map.Add("TWSS_JISB0", 34);
            map.Add("TWSS_JISB1", 35);
            map.Add("TWSS_JISB2", 36);
            map.Add("TWSS_JISB3", 37);
            map.Add("TWSS_JISB4", 38);
            map.Add("TWSS_JISB6", 39);
            map.Add("TWSS_JISB7", 40);
            map.Add("TWSS_JISB8", 41);
            map.Add("TWSS_JISB9", 42);
            map.Add("TWSS_JISB10", 43);
            map.Add("TWSS_C0", 44);
            map.Add("TWSS_C1", 45);
            map.Add("TWSS_C2", 46);
            map.Add("TWSS_C3", 47);
            map.Add("TWSS_C7", 48);
            map.Add("TWSS_C8", 49);
            map.Add("TWSS_C9", 50);
            map.Add("TWSS_C10", 51);
            map.Add("TWSS_USSTATEMENT", 52);
            map.Add("TWSS_BUSINESSCARD", 53);
            map.Add("TWSS_MAXSIZE", 54);

            /* ICAP_XFERMECH values (SX_ means Setup XFer) */
            map.Add("TWSX_NATIVE", 0);
            map.Add("TWSX_FILE", 1);
            map.Add("TWSX_MEMORY", 2);
            map.Add("TWSX_MEMFILE", 4);

            /* ICAP_UNITS values (UN_ means UNits) */
            map.Add("TWUN_INCHES", 0);
            map.Add("TWUN_CENTIMETERS", 1);
            map.Add("TWUN_PICAS", 2);
            map.Add("TWUN_POINTS", 3);
            map.Add("TWUN_TWIPS", 4);
            map.Add("TWUN_PIXELS", 5);
            map.Add("TWUN_MILLIMETERS", 6);

            /****************************************************************************
             * Country Constants                                                        *
             ****************************************************************************/

            map.Add("TWCY_AFGHANISTAN", 1001);
            map.Add("TWCY_ALGERIA", 213);
            map.Add("TWCY_AMERICANSAMOA", 684);
            map.Add("TWCY_ANDORRA", 033);
            map.Add("TWCY_ANGOLA", 1002);
            map.Add("TWCY_ANGUILLA", 8090);
            map.Add("TWCY_ANTIGUA", 8091);
            map.Add("TWCY_ARGENTINA", 54);
            map.Add("TWCY_ARUBA", 297);
            map.Add("TWCY_ASCENSIONI", 247);
            map.Add("TWCY_AUSTRALIA", 61);
            map.Add("TWCY_AUSTRIA", 43);
            map.Add("TWCY_BAHAMAS", 8092);
            map.Add("TWCY_BAHRAIN", 973);
            map.Add("TWCY_BANGLADESH", 880);
            map.Add("TWCY_BARBADOS", 8093);
            map.Add("TWCY_BELGIUM", 32);
            map.Add("TWCY_BELIZE", 501);
            map.Add("TWCY_BENIN", 229);
            map.Add("TWCY_BERMUDA", 8094);
            map.Add("TWCY_BHUTAN", 1003);
            map.Add("TWCY_BOLIVIA", 591);
            map.Add("TWCY_BOTSWANA", 267);
            map.Add("TWCY_BRITAIN", 6);
            map.Add("TWCY_BRITVIRGINIS", 8095);
            map.Add("TWCY_BRAZIL", 55);
            map.Add("TWCY_BRUNEI", 673);
            map.Add("TWCY_BULGARIA", 359);
            map.Add("TWCY_BURKINAFASO", 1004);
            map.Add("TWCY_BURMA", 1005);
            map.Add("TWCY_BURUNDI", 1006);
            map.Add("TWCY_CAMAROON", 237);
            map.Add("TWCY_CANADA", 2);
            map.Add("TWCY_CAPEVERDEIS", 238);
            map.Add("TWCY_CAYMANIS", 8096);
            map.Add("TWCY_CENTRALAFREP", 1007);
            map.Add("TWCY_CHAD", 1008);
            map.Add("TWCY_CHILE", 56);
            map.Add("TWCY_CHINA", 86);
            map.Add("TWCY_CHRISTMASIS", 1009);
            map.Add("TWCY_COCOSIS", 1009);
            map.Add("TWCY_COLOMBIA", 57);
            map.Add("TWCY_COMOROS", 1010);
            map.Add("TWCY_CONGO", 1011);
            map.Add("TWCY_COOKIS", 1012);
            map.Add("TWCY_COSTARICA", 506);
            map.Add("TWCY_CUBA", 005);
            map.Add("TWCY_CYPRUS", 357);
            map.Add("TWCY_CZECHOSLOVAKIA", 42);
            map.Add("TWCY_DENMARK", 45);
            map.Add("TWCY_DJIBOUTI", 1013);
            map.Add("TWCY_DOMINICA", 8097);
            map.Add("TWCY_DOMINCANREP", 8098);
            map.Add("TWCY_EASTERIS", 1014);
            map.Add("TWCY_ECUADOR", 593);
            map.Add("TWCY_EGYPT", 20);
            map.Add("TWCY_ELSALVADOR", 503);
            map.Add("TWCY_EQGUINEA", 1015);
            map.Add("TWCY_ETHIOPIA", 251);
            map.Add("TWCY_FALKLANDIS", 1016);
            map.Add("TWCY_FAEROEIS", 298);
            map.Add("TWCY_FIJIISLANDS", 679);
            map.Add("TWCY_FINLAND", 358);
            map.Add("TWCY_FRANCE", 33);
            map.Add("TWCY_FRANTILLES", 596);
            map.Add("TWCY_FRGUIANA", 594);
            map.Add("TWCY_FRPOLYNEISA", 689);
            map.Add("TWCY_FUTANAIS", 1043);
            map.Add("TWCY_GABON", 241);
            map.Add("TWCY_GAMBIA", 220);
            map.Add("TWCY_GERMANY", 49);
            map.Add("TWCY_GHANA", 233);
            map.Add("TWCY_GIBRALTER", 350);
            map.Add("TWCY_GREECE", 30);
            map.Add("TWCY_GREENLAND", 299);
            map.Add("TWCY_GRENADA", 8099);
            map.Add("TWCY_GRENEDINES", 8015);
            map.Add("TWCY_GUADELOUPE", 590);
            map.Add("TWCY_GUAM", 671);
            map.Add("TWCY_GUANTANAMOBAY", 5399);
            map.Add("TWCY_GUATEMALA", 502);
            map.Add("TWCY_GUINEA", 224);
            map.Add("TWCY_GUINEABISSAU", 1017);
            map.Add("TWCY_GUYANA", 592);
            map.Add("TWCY_HAITI", 509);
            map.Add("TWCY_HONDURAS", 504);
            map.Add("TWCY_HONGKONG", 852);
            map.Add("TWCY_HUNGARY", 36);
            map.Add("TWCY_ICELAND", 354);
            map.Add("TWCY_INDIA", 91);
            map.Add("TWCY_INDONESIA", 62);
            map.Add("TWCY_IRAN", 98);
            map.Add("TWCY_IRAQ", 964);
            map.Add("TWCY_IRELAND", 353);
            map.Add("TWCY_ISRAEL", 972);
            map.Add("TWCY_ITALY", 39);
            map.Add("TWCY_IVORYCOAST", 225);
            map.Add("TWCY_JAMAICA", 8010);
            map.Add("TWCY_JAPAN", 81);
            map.Add("TWCY_JORDAN", 962);
            map.Add("TWCY_KENYA", 254);
            map.Add("TWCY_KIRIBATI", 1018);
            map.Add("TWCY_KOREA", 82);
            map.Add("TWCY_KUWAIT", 965);
            map.Add("TWCY_LAOS", 1019);
            map.Add("TWCY_LEBANON", 1020);
            map.Add("TWCY_LIBERIA", 231);
            map.Add("TWCY_LIBYA", 218);
            map.Add("TWCY_LIECHTENSTEIN", 41);
            map.Add("TWCY_LUXENBOURG", 352);
            map.Add("TWCY_MACAO", 853);
            map.Add("TWCY_MADAGASCAR", 1021);
            map.Add("TWCY_MALAWI", 265);
            map.Add("TWCY_MALAYSIA", 60);
            map.Add("TWCY_MALDIVES", 960);
            map.Add("TWCY_MALI", 1022);
            map.Add("TWCY_MALTA", 356);
            map.Add("TWCY_MARSHALLIS", 692);
            map.Add("TWCY_MAURITANIA", 1023);
            map.Add("TWCY_MAURITIUS", 230);
            map.Add("TWCY_MEXICO", 3);
            map.Add("TWCY_MICRONESIA", 691);
            map.Add("TWCY_MIQUELON", 508);
            map.Add("TWCY_MONACO", 33);
            map.Add("TWCY_MONGOLIA", 1024);
            map.Add("TWCY_MONTSERRAT", 8011);
            map.Add("TWCY_MOROCCO", 212);
            map.Add("TWCY_MOZAMBIQUE", 1025);
            map.Add("TWCY_NAMIBIA", 264);
            map.Add("TWCY_NAURU", 1026);
            map.Add("TWCY_NEPAL", 977);
            map.Add("TWCY_NETHERLANDS", 31);
            map.Add("TWCY_NETHANTILLES", 599);
            map.Add("TWCY_NEVIS", 8012);
            map.Add("TWCY_NEWCALEDONIA", 687);
            map.Add("TWCY_NEWZEALAND", 64);
            map.Add("TWCY_NICARAGUA", 505);
            map.Add("TWCY_NIGER", 227);
            map.Add("TWCY_NIGERIA", 234);
            map.Add("TWCY_NIUE", 1027);
            map.Add("TWCY_NORFOLKI", 1028);
            map.Add("TWCY_NORWAY", 47);
            map.Add("TWCY_OMAN", 968);
            map.Add("TWCY_PAKISTAN", 92);
            map.Add("TWCY_PALAU", 1029);
            map.Add("TWCY_PANAMA", 507);
            map.Add("TWCY_PARAGUAY", 595);
            map.Add("TWCY_PERU", 51);
            map.Add("TWCY_PHILLIPPINES", 63);
            map.Add("TWCY_PITCAIRNIS", 1030);
            map.Add("TWCY_PNEWGUINEA", 675);
            map.Add("TWCY_POLAND", 48);
            map.Add("TWCY_PORTUGAL", 351);
            map.Add("TWCY_QATAR", 974);
            map.Add("TWCY_REUNIONI", 1031);
            map.Add("TWCY_ROMANIA", 40);
            map.Add("TWCY_RWANDA", 250);
            map.Add("TWCY_SAIPAN", 670);
            map.Add("TWCY_SANMARINO", 39);
            map.Add("TWCY_SAOTOME", 1033);
            map.Add("TWCY_SAUDIARABIA", 966);
            map.Add("TWCY_SENEGAL", 221);
            map.Add("TWCY_SEYCHELLESIS", 1034);
            map.Add("TWCY_SIERRALEONE", 1035);
            map.Add("TWCY_SINGAPORE", 65);
            map.Add("TWCY_SOLOMONIS", 1036);
            map.Add("TWCY_SOMALI", 1037);
            map.Add("TWCY_SOUTHAFRICA", 27);
            map.Add("TWCY_SPAIN", 34);
            map.Add("TWCY_SRILANKA", 94);
            map.Add("TWCY_STHELENA", 1032);
            map.Add("TWCY_STKITTS", 8013);
            map.Add("TWCY_STLUCIA", 8014);
            map.Add("TWCY_STPIERRE", 508);
            map.Add("TWCY_STVINCENT", 8015);
            map.Add("TWCY_SUDAN", 1038);
            map.Add("TWCY_SURINAME", 597);
            map.Add("TWCY_SWAZILAND", 268);
            map.Add("TWCY_SWEDEN", 46);
            map.Add("TWCY_SWITZERLAND", 41);
            map.Add("TWCY_SYRIA", 1039);
            map.Add("TWCY_TAIWAN", 886);
            map.Add("TWCY_TANZANIA", 255);
            map.Add("TWCY_THAILAND", 66);
            map.Add("TWCY_TOBAGO", 8016);
            map.Add("TWCY_TOGO", 228);
            map.Add("TWCY_TONGAIS", 676);
            map.Add("TWCY_TRINIDAD", 8016);
            map.Add("TWCY_TUNISIA", 216);
            map.Add("TWCY_TURKEY", 90);
            map.Add("TWCY_TURKSCAICOS", 8017);
            map.Add("TWCY_TUVALU", 1040);
            map.Add("TWCY_UGANDA", 256);
            map.Add("TWCY_USSR", 7);
            map.Add("TWCY_UAEMIRATES", 971);
            map.Add("TWCY_UNITEDKINGDOM", 44);
            map.Add("TWCY_USA", 1);
            map.Add("TWCY_URUGUAY", 598);
            map.Add("TWCY_VANUATU", 1041);
            map.Add("TWCY_VATICANCITY", 39);
            map.Add("TWCY_VENEZUELA", 58);
            map.Add("TWCY_WAKE", 1042);
            map.Add("TWCY_WALLISIS", 1043);
            map.Add("TWCY_WESTERNSAHARA", 1044);
            map.Add("TWCY_WESTERNSAMOA", 1045);
            map.Add("TWCY_YEMEN", 1046);
            map.Add("TWCY_YUGOSLAVIA", 38);
            map.Add("TWCY_ZAIRE", 243);
            map.Add("TWCY_ZAMBIA", 260);
            map.Add("TWCY_ZIMBABWE", 263);
            map.Add("TWCY_ALBANIA", 355);
            map.Add("TWCY_ARMENIA", 374);
            map.Add("TWCY_AZERBAIJAN", 994);
            map.Add("TWCY_BELARUS", 375);
            map.Add("TWCY_BOSNIAHERZGO", 387);
            map.Add("TWCY_CAMBODIA", 855);
            map.Add("TWCY_CROATIA", 385);
            map.Add("TWCY_CZECHREPUBLIC", 420);
            map.Add("TWCY_DIEGOGARCIA", 246);
            map.Add("TWCY_ERITREA", 291);
            map.Add("TWCY_ESTONIA", 372);
            map.Add("TWCY_GEORGIA", 995);
            map.Add("TWCY_LATVIA", 371);
            map.Add("TWCY_LESOTHO", 266);
            map.Add("TWCY_LITHUANIA", 370);
            map.Add("TWCY_MACEDONIA", 389);
            map.Add("TWCY_MAYOTTEIS", 269);
            map.Add("TWCY_MOLDOVA", 373);
            map.Add("TWCY_MYANMAR", 95);
            map.Add("TWCY_NORTHKOREA", 850);
            map.Add("TWCY_PUERTORICO", 787);
            map.Add("TWCY_RUSSIA", 7);
            map.Add("TWCY_SERBIA", 381);
            map.Add("TWCY_SLOVAKIA", 421);
            map.Add("TWCY_SLOVENIA", 386);
            map.Add("TWCY_SOUTHKOREA", 82);
            map.Add("TWCY_UKRAINE", 380);
            map.Add("TWCY_USVIRGINIS", 340);
            map.Add("TWCY_VIETNAM", 84);

            /****************************************************************************
             * Language Constants                                                       *
             ****************************************************************************/
            map.Add("TWLG_USERLOCALE", -1);
            map.Add("TWLG_DAN", 0);
            map.Add("TWLG_DUT", 1);
            map.Add("TWLG_ENG", 2);
            map.Add("TWLG_FCF", 3);
            map.Add("TWLG_FIN", 4);
            map.Add("TWLG_FRN", 5);
            map.Add("TWLG_GER", 6);
            map.Add("TWLG_ICE", 7);
            map.Add("TWLG_ITN", 8);
            map.Add("TWLG_NOR", 9);
            map.Add("TWLG_POR", 10);
            map.Add("TWLG_SPA", 11);
            map.Add("TWLG_SWE", 12);
            map.Add("TWLG_USA", 13);
            map.Add("TWLG_AFRIKAANS", 14);
            map.Add("TWLG_ALBANIA", 15);
            map.Add("TWLG_ARABIC", 16);
            map.Add("TWLG_ARABIC_ALGERIA", 17);
            map.Add("TWLG_ARABIC_BAHRAIN", 18);
            map.Add("TWLG_ARABIC_EGYPT", 19);
            map.Add("TWLG_ARABIC_IRAQ", 20);
            map.Add("TWLG_ARABIC_JORDAN", 21);
            map.Add("TWLG_ARABIC_KUWAIT", 22);
            map.Add("TWLG_ARABIC_LEBANON", 23);
            map.Add("TWLG_ARABIC_LIBYA", 24);
            map.Add("TWLG_ARABIC_MOROCCO", 25);
            map.Add("TWLG_ARABIC_OMAN", 26);
            map.Add("TWLG_ARABIC_QATAR", 27);
            map.Add("TWLG_ARABIC_SAUDIARABIA", 28);
            map.Add("TWLG_ARABIC_SYRIA", 29);
            map.Add("TWLG_ARABIC_TUNISIA", 30);
            map.Add("TWLG_ARABIC_UAE", 31);
            map.Add("TWLG_ARABIC_YEMEN", 32);
            map.Add("TWLG_BASQUE", 33);
            map.Add("TWLG_BYELORUSSIAN", 34);
            map.Add("TWLG_BULGARIAN", 35);
            map.Add("TWLG_CATALAN", 36);
            map.Add("TWLG_CHINESE", 37);
            map.Add("TWLG_CHINESE_HONGKONG", 38);
            map.Add("TWLG_CHINESE_PRC", 39);
            map.Add("TWLG_CHINESE_SINGAPORE", 40);
            map.Add("TWLG_CHINESE_SIMPLIFIED", 41);
            map.Add("TWLG_CHINESE_TAIWAN", 42);
            map.Add("TWLG_CHINESE_TRADITIONAL", 43);
            map.Add("TWLG_CROATIA", 44);
            map.Add("TWLG_CZECH", 45);
            map.Add("TWLG_DANISH", TWLG_DAN);
            map.Add("TWLG_DUTCH", TWLG_DUT);
            map.Add("TWLG_DUTCH_BELGIAN", 46);
            map.Add("TWLG_ENGLISH", TWLG_ENG);
            map.Add("TWLG_ENGLISH_AUSTRALIAN", 47);
            map.Add("TWLG_ENGLISH_CANADIAN", 48);
            map.Add("TWLG_ENGLISH_IRELAND", 49);
            map.Add("TWLG_ENGLISH_NEWZEALAND", 50);
            map.Add("TWLG_ENGLISH_SOUTHAFRICA", 51);
            map.Add("TWLG_ENGLISH_UK", 52);
            map.Add("TWLG_ENGLISH_USA", TWLG_USA);
            map.Add("TWLG_ESTONIAN", 53);
            map.Add("TWLG_FAEROESE", 54);
            map.Add("TWLG_FARSI", 55);
            map.Add("TWLG_FINNISH", TWLG_FIN);
            map.Add("TWLG_FRENCH", TWLG_FRN);
            map.Add("TWLG_FRENCH_BELGIAN", 56);
            map.Add("TWLG_FRENCH_CANADIAN", TWLG_FCF);
            map.Add("TWLG_FRENCH_LUXEMBOURG", 57);
            map.Add("TWLG_FRENCH_SWISS", 58);
            map.Add("TWLG_GERMAN", TWLG_GER);
            map.Add("TWLG_GERMAN_AUSTRIAN", 59);
            map.Add("TWLG_GERMAN_LUXEMBOURG", 60);
            map.Add("TWLG_GERMAN_LIECHTENSTEIN", 61);
            map.Add("TWLG_GERMAN_SWISS", 62);
            map.Add("TWLG_GREEK", 63);
            map.Add("TWLG_HEBREW", 64);
            map.Add("TWLG_HUNGARIAN", 65);
            map.Add("TWLG_ICELANDIC", TWLG_ICE);
            map.Add("TWLG_INDONESIAN", 66);
            map.Add("TWLG_ITALIAN", TWLG_ITN);
            map.Add("TWLG_ITALIAN_SWISS", 67);
            map.Add("TWLG_JAPANESE", 68);
            map.Add("TWLG_KOREAN", 69);
            map.Add("TWLG_KOREAN_JOHAB", 70);
            map.Add("TWLG_LATVIAN", 71);
            map.Add("TWLG_LITHUANIAN", 72);
            map.Add("TWLG_NORWEGIAN", TWLG_NOR);
            map.Add("TWLG_NORWEGIAN_BOKMAL", 73);
            map.Add("TWLG_NORWEGIAN_NYNORSK", 74);
            map.Add("TWLG_POLISH", 75);
            map.Add("TWLG_PORTUGUESE", TWLG_POR);
            map.Add("TWLG_PORTUGUESE_BRAZIL", 76);
            map.Add("TWLG_ROMANIAN", 77);
            map.Add("TWLG_RUSSIAN", 78);
            map.Add("TWLG_SERBIAN_LATIN", 79);
            map.Add("TWLG_SLOVAK", 80);
            map.Add("TWLG_SLOVENIAN", 81);
            map.Add("TWLG_SPANISH", TWLG_SPA);
            map.Add("TWLG_SPANISH_MEXICAN", 82);
            map.Add("TWLG_SPANISH_MODERN", 83);
            map.Add("TWLG_SWEDISH", TWLG_SWE);
            map.Add("TWLG_THAI", 84);
            map.Add("TWLG_TURKISH", 85);
            map.Add("TWLG_UKRANIAN", 86);
            map.Add("TWLG_ASSAMESE", 87);
            map.Add("TWLG_BENGALI", 88);
            map.Add("TWLG_BIHARI", 89);
            map.Add("TWLG_BODO", 90);
            map.Add("TWLG_DOGRI", 91);
            map.Add("TWLG_GUJARATI", 92);
            map.Add("TWLG_HARYANVI", 93);
            map.Add("TWLG_HINDI", 94);
            map.Add("TWLG_KANNADA", 95);
            map.Add("TWLG_KASHMIRI", 96);
            map.Add("TWLG_MALAYALAM", 97);
            map.Add("TWLG_MARATHI", 98);
            map.Add("TWLG_MARWARI", 99);
            map.Add("TWLG_MEGHALAYAN", 100);
            map.Add("TWLG_MIZO", 101);
            map.Add("TWLG_NAGA", 102);
            map.Add("TWLG_ORISSI", 103);
            map.Add("TWLG_PUNJABI", 104);
            map.Add("TWLG_PUSHTU", 105);
            map.Add("TWLG_SERBIAN_CYRILLIC", 106);
            map.Add("TWLG_SIKKIMI", 107);
            map.Add("TWLG_SWEDISH_FINLAND", 108);
            map.Add("TWLG_TAMIL", 109);
            map.Add("TWLG_TELUGU", 110);
            map.Add("TWLG_TRIPURI", 111);
            map.Add("TWLG_URDU", 112);
            map.Add("TWLG_VIETNAMESE", 113);

            mapConstantNameToIntValue = map;
            return mapConstantNameToIntValue;
        }

        /// <summary>
        /// List of all twain constant names.
        /// </summary>
        /// <returns></returns>
        public static List<string> getConstants()
        {
            Dictionary<string, int> map = getMapConstantNameToIntValue();
            List<string> list = new List<string>(map.Keys);
            list.Sort();
            return list;
        }

        /// <summary>
        /// Returns the readable name of the pixel type.
        /// </summary>
        /// <param name="pixelType"></param>
        /// <returns></returns>
        public static string getPixelTypeName(int pixelType)
        {
            switch (pixelType)
            {
                case TWPT_BW:
                    return "Black/white";
                case TWPT_GRAY:
                    return "Gray";
                case TWPT_RGB:
                    return "RGB";
                default:
                    return "" + pixelType;
            }
        }
    }
}
